{$n+,e-,d+,l+,y+}
uses func_ops,dos;
const x1:extended=+2.0;
      x2:extended=4.9;

const
    _e      :extended=2.718281828459045240;
    _onehalf:extended=0.5;
    _delta  :extended=0.001995;
    _ezero  :extended=0.001995;
    IsSolid :boolean=false;

var x:extended;
    h1,m1,s1,c1,h2,m2,s2,c2:word;
    i:longint;
const
      c_fabs=$E1D9;
      c_fadd=$C1DC;
      c_faddp=$C1DE;
      c_fchs=$E0D9;
      c_fcompp=$D9DE;
      c_fdivp=$F9DE;
      c_fdivrp=$F1DE;
      c_fildw_bp=$86DF;
      c_fildd_bp=$86DB;
      c_fildq_bp=$AEDF;
      c_fistpd_bp=$9EDB;
      c_fistpq_bp=$BEDF;
      c_fld=$2EDB;
      c_fldcw_bp=$AED9;
      c_fldcw=$2ED9;
      c_fldlg2=$ECD9;
      c_fldln2=$EDD9;
      c_fldl2e=$EAD9;
      c_fldpi=$EBD9;
      c_fldz=$EED9;
      c_fld1=$E8D9;
      c_fld_bp=$AEDB;
      c_fld_st=$C0D9;
      c_fld_st0=$C0D9;
      c_fmul=$C9DC;
      c_fmulp=$C9DE;
      c_fpatan=$F3D9;
      c_frndint=$FCD9;
      c_fscale=$FDD9;
      c_fsin=$FED9;
      c_fcos=$FFD9;
      c_fsqr=$C8DC;
      c_fsqrt=$FAD9;
      c_fstcw_bp=$BED9;
      c_fstcw=$3ED9;
      c_fstp=$3EDB;
      c_fstp_bp=$BEDB;
      c_fstp_bx=$BFDB;
      c_fstp_st0=$D8DD;
      c_fstp_st1=$D9DD;
      c_fstsw_ax=$E0DF;
      c_fsub=$E9DC;
      c_fsubp=$E9DE;
      c_fsubrp=$E1DE;
      c_fsub_st1=$E9DC;
      c_ftst=$E4D9;
      c_fxam=$E5D9;
      c_fxch=$C9D9;
      c_fyl2x=$F1D9;
      c_f2xm1=$F0D9;

      p_cs=$2e;
      p_ds=$3e;
      p_es=$26;
      p_ss=$36;

      cw_rcm=$0C00;
      sw_cn1=$8500;
      sw_c=$8700;
      sw_pln=$0400;
      sw_mnn=$0600;
      sw_stl=$0100;

function __zero:boolean;assembler;
asm
  dw c_fld_st0
  dw c_fabs
  dw c_fld, _delta
{  dw c_fxch}
  dw c_fcompp
  dw c_fstsw_ax
  and ah,01000101b
  test ah,00000100b
  jz @@l1
{  dw c_fld, _ezero}
  xor al,al
  jmp @@fin
@@l1:
  or ah,ah
  jnz @@l2
  mov al,1
  jmp @@fin
@@l2:
  xor al,al
@@fin:
end;

function f_plus(a,b:extended):extended;assembler;
asm
  dw c_fld_bp,a
  dw c_fld_bp,b
  dw c_faddp
end;

function f_minus(a,b:extended):extended;assembler;
asm
  dw c_fld_bp,a
  dw c_fld_bp,b
  dw c_fsubp
end;

function f_mul(a,b:extended):extended;assembler;
asm
  dw c_fld_bp,a
  dw c_fld_bp,b
  dw c_fmulp
end;

function f_div(a,b:extended):extended;assembler;
asm
  dw c_fld_bp,b
  call __zero
  or al,al
  jz @@l1
  dw c_fstp_st1-$100
  dw c_fld,_ezero
  jmp @@fin
@@l1:
  dw c_fld_bp,a
  dw c_fdivrp
@@fin:
end;

function f_Power(x1,x2:extended):extended;assembler;
var cw:word;
    l:array[0..1]of longint;
asm
  dw c_fld_bp,x1
  call __zero{if a=0}
  or al,al
  jz @@l1
  dw c_fstp_st0
  dw c_fld_bp,x2
  call __zero{if b=0}
  dw c_fstp_st0
  or al,al
  jz @@l0_1
  dw c_fld,_ezero{pow:=ezero}
@@l0_1:
  dw c_fldz{pow:=0}
@@l1:
  dw c_fabs
  dw c_fld1
  dw c_fxch
  dw c_fyl2x
  dw c_fld_bp,x2
  dw c_fmulp
  dw c_fld_st0
  dw c_fabs
{  mov ax,15860
  mov cw,ax}
  mov cw,15860
  dw c_fildw_bp,cw
  dw c_fcompp{if abs(b*ln(abs(a)))>1.1e4}
  dw c_fstsw_ax
  and ah,01000101b
  test ah,1
  jz @@l2
  dw c_fstp_st0
  dw c_fld,_ezero
  jmp @@fin
@@l2:
  dw c_fld_bp,x2

  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
{  or ax,0000h}
  mov cw,ax
  dw c_fldcw_bp,cw
  dw c_fld_st0
  dw c_frndint
  dw c_fsub
  call __zero {if int(b)=b}
{  dw c_fstp_st0}
  dw c_fstp_st1
  or al,al
  jz @@l3
  dw c_fistpq_bp,l[0]
  mov al,byte ptr l[0]
  shr al,1
  jc @@l2_1
{int(b/2)=b/2}
  dw c_fld1
  jmp @@l2_2
@@l2_1:
  dw c_fld_bp,x1
  dw c_ftst
  dw c_fstsw_ax
  dw c_fstp_st0
  dw c_fld1
  and ah,01000101b
  jz @@l2_2
  dw c_fchs
@@l2_2:
  jmp @@l4
@@l3:
{int(b)<>b}
  dw c_fld_bp,x1
  dw c_ftst
  dw c_fstsw_ax
  dw c_fstp_st0
  and ah,01000101b
  jz @@l4
  dw c_fstp_st0
  dw c_fld,_ezero
  jmp @@fin
@@l4:
{exp()}
  dw c_fld1
  dw c_fld1
  dw c_fld1
  dw c_fadd-100h
  dw c_fyl2x
{  db p_ss
  dw c_fld_bp,x2}
  dw c_fldl2e
  dw c_fmulp
{}
{  db p_ss}
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
{  db p_ss}
  dw c_fldcw_bp,cw
  dw c_fld_st
  dw c_frndint
  dw c_fsub_st1
  dw c_fld1
  dw c_fscale
  dw c_fstp_st1
  dw c_fxch
  dw c_f2xm1
  dw c_fld1
  dw c_faddp
  dw c_fmulp
{e}
  dw c_fyl2x
{  db p_ss}
  dw c_fld_st0+$100
  dw c_fmulp
{}
{  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw}
  dw c_fld_st
  dw c_frndint
  dw c_fsub_st1
  dw c_fld1
  dw c_fscale
  dw c_fstp_st1
  dw c_fxch
  dw c_f2xm1
  dw c_fld1
  dw c_faddp
  dw c_fmulp
@@fin:
end;

(*function f_e:extended;assembler;
var cw:word;
asm
  dw c_fld1
{  db p_ss
  dw c_fld_bp,x1}
  dw c_fld1
  dw c_fadd-100h
  dw c_fyl2x
{  db p_ss
  dw c_fld_bp,x2}
  dw c_fldl2e
  dw c_fmulp
{}
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
  dw c_fld_st
  dw c_frndint
  dw c_fsub_st1
  dw c_fld1
  dw c_fscale
  dw c_fstp_st1
  dw c_fxch
  dw c_f2xm1
  dw c_fld1
  dw c_faddp
  dw c_fmulp
end;*)

function f_e:extended;assembler;
asm
  dw c_fld,_e
end;

function fround(x:extended):extended;assembler;
var cw:word;
asm
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
  dw c_fld,_onehalf
  db p_ss
  dw c_fld_bp,x
  dw c_faddp
  dw c_frndint
end;

function fmax(x1,x2:extended):extended;assembler;
{var cw:word;}
asm
  db p_ss
  dw c_fld_bp,x1
  db p_ss
  dw c_fld_bp,x2
  dw c_fcompp
  dw c_fstsw_ax
  and ah,01000101b
{  or ax,ax}
  jnz @@l1
{b>a}
  db p_ss
  dw c_fld_bp,x2
  jmp @@fin
@@l1:
{  cmp ah,1
  jne @@l2}
{b<a}
  db p_ss
  dw c_fld_bp,x1
{  jmp @@fin}
@@fin:
end;

function fmin(x1,x2:extended):extended;assembler;
{var cw:word;}
asm
  db p_ss
  dw c_fld_bp,x1
  db p_ss
  dw c_fld_bp,x2
  dw c_fcompp
  dw c_fstsw_ax
  and ah,01000101b
{  or ax,ax}
  jnz @@l1
{b>a}
  db p_ss
  dw c_fld_bp,x1
  jmp @@fin
@@l1:
{  cmp ah,1
  jne @@l2}
{b<a}
  db p_ss
  dw c_fld_bp,x2
{  jmp @@fin}
@@fin:
end;

function fimod(x1,x2:extended):extended;assembler;
var cw:word;
asm
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
{  dw c_fld,_onehalf}
  db p_ss
  dw c_fld_bp,x1
  db p_ss
  dw c_fld_bp,x2
  dw c_fld_st+$100
  dw c_fld_st+$100
  dw c_fdivp
{  dw c_faddp}
  dw c_frndint
  dw c_fmulp
  dw c_fsubp
end;

function fph(x1:extended):extended;assembler;
var cw:word;
asm
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
{  dw c_fld,_onehalf}
  db p_ss
  dw c_fld_bp,x1
{  db p_ss
  dw c_fld_bp,x2}
  dw c_fldpi
  dw c_fld_st+$100
  dw c_fld_st+$100
  dw c_fdivp
{  dw c_faddp}
  dw c_frndint
  dw c_fmulp
  dw c_fsubp
end;

function fexp(x:extended):extended;assembler;
var cw:word;
asm
  dw c_fld1

  dw c_fld1
{  db p_ss
  dw c_fld_bp,x1}
  dw c_fld1
  dw c_fadd-100h
  dw c_fyl2x
{  db p_ss
  dw c_fld_bp,x2}
  dw c_fldl2e
  dw c_fmulp
{}
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
  dw c_fld_st
  dw c_frndint
  dw c_fsub_st1
  dw c_fld1
  dw c_fscale
  dw c_fstp_st1
  dw c_fxch
  dw c_f2xm1
  dw c_fld1
  dw c_faddp
  dw c_fmulp
{e}
  dw c_fyl2x
  db p_ss
  dw c_fld_bp,x
  dw c_fmulp
{}
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
  dw c_fld_st
  dw c_frndint
  dw c_fsub_st1
  dw c_fld1
  dw c_fscale
  dw c_fstp_st1
  dw c_fxch
  dw c_f2xm1
  dw c_fld1
  dw c_faddp
  dw c_fmulp
end;

function th(x:extended):extended;assembler;
var cw:word;
asm
  db p_ss
  dw c_fld_bp,x
  mov bx,sp
  sub bx,10
  mov sp,bx
  db p_ss
  dw c_fstp_bx
  dw 0
  call fexp

  dw c_fld_st
  dw c_fld1
  dw c_fdivrp

  dw c_fld_st+$100
  dw c_fld_st+$100
  dw c_fchs
  dw c_faddp

  dw c_fxch+100h
  dw c_faddp
  dw c_fdivp
end;

function cth(x:extended):extended;assembler;
var cw:word;
asm
  db p_ss
  dw c_fld_bp,x
  mov bx,sp
  sub bx,10
  mov sp,bx
  db p_ss
  dw c_fstp_bx
  dw 0
  call fexp

  dw c_fld_st
  dw c_fld1
  dw c_fdivrp

  dw c_fld_st+$100
  dw c_fld_st+$100
  dw c_fchs
  dw c_faddp

  dw c_fxch+100h
  dw c_faddp
  dw c_fdivrp
end;

function sh(x:extended):extended;assembler;
var cw:word;
asm
  db p_ss
  dw c_fld_bp,x
  mov bx,sp
  sub bx,10
  mov sp,bx
  db p_ss
  dw c_fstp_bx
  dw 0
  call fexp

  dw c_fld_st
  dw c_fld1
  dw c_fdivrp
  dw c_fchs
  dw c_faddp
  dw c_fld1
  dw c_fadd-100h
  dw c_fdivp
end;

function ch(x:extended):extended;assembler;
var cw:word;
asm
  db p_ss
  dw c_fld_bp,x
  mov bx,sp
  sub bx,10
  mov sp,bx
  db p_ss
  dw c_fstp_bx
  dw 0
  call fexp

  dw c_fld_st
  dw c_fld1
  dw c_fdivrp
{  dw c_fchs}
  dw c_faddp
  dw c_fld1
  dw c_fadd-100h
  dw c_fdivp
end;

function f_pi:extended;assembler;
asm
  dw c_fldpi
end;

function log(x1,x2:extended):extended;assembler;
var cw:word;
asm
  dw c_fld1
  db p_ss
  dw c_fld_bp,x2
  dw c_fyl2x
  dw c_fld1
  dw c_fdivrp
  db p_ss
  dw c_fld_bp,x1
  dw c_fyl2x
end;

function pow2(x:extended):extended;assembler;
var cw:word;
asm
  db p_ss
  dw c_fld_bp,x
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
  dw c_fld_st
  dw c_frndint
  dw c_fsub_st1
  dw c_fld1
  dw c_fscale
  dw c_fstp_st1
  dw c_fxch
  dw c_f2xm1
  dw c_fld1
  dw c_faddp
  dw c_fmulp
{  db p_ss}
{  dw c_fstp_bp,pow2}
end;

function fabs(x:extended):extended;assembler;
asm
  db p_ss
  dw c_fld_bp,x
  dw c_fabs
end;

function fsqr(x:extended):extended;assembler;
asm
  db p_ss
  dw c_fld_bp,x
  dw c_fmul-$100
end;

function fsqrt(x:extended):extended;assembler;
asm
  db p_ss
  dw c_fld_bp,x
  dw c_fsqrt
end;

function farsh(x:extended):extended;assembler;
asm
  dw c_fld1
  db p_ss
  dw c_fld_bp,x
  dw c_fld_st0
  dw c_fld_st0
  dw c_fmulp
  dw c_fld1
  dw c_faddp
  dw c_fsqrt
  dw c_faddp
  dw c_fyl2x
  dw c_fldln2
  dw c_fmulp
end;

function farch(x:extended):extended;assembler;
asm
  dw c_fld1
  db p_ss
  dw c_fld_bp,x
  dw c_fld_st0
  dw c_fld_st0
  dw c_fmulp
  dw c_fld1
  dw c_fchs
  dw c_faddp
  dw c_fsqrt
  dw c_faddp
  dw c_fyl2x
  dw c_fldln2
  dw c_fmulp
end;

function farth(x:extended):extended;assembler;
asm{x<1}
  dw c_fld1
  db p_ss
  dw c_fld_bp,x
  dw c_fld_st0
  dw c_fld1
  dw c_faddp
{  dw c_fld_st0+$100}
  dw c_fld1
  dw c_fsubrp+$100
  dw c_fdivrp
  dw c_fyl2x
  dw c_fldln2
  dw c_fmulp
  dw c_fld1
  dw c_fadd-$100
  dw c_fdivp
end;

function farcth(x:extended):extended;assembler;
asm{x<1}
  dw c_fld1
  db p_ss
  dw c_fld_bp,x
  dw c_fld_st0
  dw c_fld1
  dw c_faddp
{  dw c_fld_st0+$100}
  dw c_fld1
  dw c_fsubp+$100
  dw c_fdivrp
  dw c_fyl2x
  dw c_fldln2
  dw c_fmulp
  dw c_fld1
  dw c_fadd-$100
  dw c_fdivp
end;

function fln(x:extended):extended;assembler;
asm
  dw c_fld1
  db p_ss
  dw c_fld_bp,x
  dw c_fyl2x
  dw c_fldln2
  dw c_fmulp
end;

function flg(x:extended):extended;assembler;
asm
  dw c_fld1
  db p_ss
  dw c_fld_bp,x
  dw c_fyl2x
  dw c_fldlg2
  dw c_fmulp
end;

function ffrac(x:extended):extended;assembler;
var cw:word;
asm
  db p_ss
  dw c_fld_bp,x
  dw c_fld_st0
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
  dw c_frndint
  dw c_fsubp
end;

function fint(x:extended):extended;assembler;
var cw:word;
asm
  db p_ss
  dw c_fld_bp,x
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
  dw c_frndint
end;

function fnot(x:extended):extended;assembler;
var cw:word;
    l:array[0..1]of longint;
asm
  db p_ss
  dw c_fld_bp,x
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
  dw c_frndint
  db p_ss
  dw c_fistpq_bp,l[0]
  db 66h
  mov ax,word ptr l[0]
  db 66h
  not ax
  db 66h
  mov word ptr l[0],ax
  db 66h
  mov ax,word ptr l[4]
  db 66h
  not ax
  db 66h
  mov word ptr l[4],ax
  db p_ss
  dw c_fildq_bp,l[0]
end;

function arcSin(x:extended):extended;assembler;
asm {x1 must be in (-1;1), spec.cases:+-1}
{    dw c_fld1}
    db p_ss
    dw c_fld_bp,x
    dw c_fld_st
    dw c_fsqr
    dw c_fchs
    dw c_fld1
    dw c_faddp
    dw c_fsqrt
{    dw c_fld,x1}
    dw c_fdivp
    dw c_fld1
    dw c_fpatan
{    dw c_fstp,x}
end;

function arcCos(x:extended):extended;assembler;
asm {x1 must be in (-1;1), spec.cases:+-1}
{    dw c_fld1}
    db p_ss
    dw c_fld_bp,x
    dw c_fld_st
    dw c_fsqr
    dw c_fchs
    dw c_fld1
    dw c_faddp
    dw c_fsqrt
{    dw c_fld,x1}
    dw c_fdivrp
    dw c_fld1
    dw c_fpatan
    db p_ss
    dw c_fld_bp,x
    dw c_fldz
    dw c_fcompp
    dw c_fstsw_ax
    and ax,sw_cn1;
    cmp ax,0
    jne @@ac1;
    dw c_fldpi
    dw c_faddp
@@ac1:
{    dw c_fstp,x}
end;

function arcCsc(x:extended):extended;assembler;
asm
    db p_ss
    dw c_fld_bp,x
    dw c_fld1
    dw c_fdivrp
    dw c_fld_st
    dw c_fsqr
    dw c_fchs
    dw c_fld1
    dw c_faddp
    dw c_fsqrt
{    dw c_fld,x1}
    dw c_fdivp
    dw c_fld1
    dw c_fpatan
{    dw c_fstp,x}
end;

function arcSc(x:extended):extended;assembler;
asm {x1 must be in (-1;1), spec.cases:+-1}
{    dw c_fld1}
    db p_ss
    dw c_fld_bp,x
    dw c_fld1
    dw c_fdivrp
    dw c_fld_st
    dw c_fsqr
    dw c_fchs
    dw c_fld1
    dw c_faddp
    dw c_fsqrt
{    dw c_fld,x1}
    dw c_fdivrp
    dw c_fld1
    dw c_fpatan
    db p_ss
    dw c_fld_bp,x
    dw c_fldz
    dw c_fcompp
    dw c_fstsw_ax
    and ax,sw_cn1;
    cmp ax,0
    jne @@ac1;
    dw c_fldpi
    dw c_faddp
@@ac1:
{    dw c_fstp,x}
end;

function Sign(x:extended):extended;assembler;
asm
    db p_ss
    dw c_fld_bp,x
    dw c_fxam
    dw c_fstsw_ax
    dw c_fstp_st1-$100
    and ax,sw_c
    cmp ax,sw_pln
    jne @@s1
{    xor ax,ax
    inc ax}
    dw c_fld1
    jmp @@s3
@@s1:
    cmp ax,sw_mnn
    jne @@s2
{    xor ax,ax
    dec ax}
    dw c_fld1
    dw c_fchs
    jmp @@s3
@@s2:
{    xor ax,ax}
    dw c_fldz
@@s3:
end;

function FHeav(x:extended):extended;assembler;
asm
    db p_ss
    dw c_fld_bp,x
    dw c_fxam
    dw c_fstsw_ax
    dw c_fstp_st1-$100
    and ax,sw_c
    cmp ax,sw_pln
    jne @@s1
    dw c_fld1
    jmp @@s3
@@s1:
    dw c_fldz
@@s3:
end;

function FSc(x:extended):extended;assembler;
asm
    db p_ss
    dw c_fld_bp,x
    dw c_fcos
    dw c_fld1
    dw c_fdivrp
end;

function FCsc(x:extended):extended;assembler;
asm
    db p_ss
    dw c_fld_bp,x
    dw c_fsin
    dw c_fld1
    dw c_fdivrp
end;

function Power(x1,x2:extended):extended;assembler;
var cw:word;
asm
  dw c_fld1
  db p_ss
  dw c_fld_bp,x1
  dw c_fyl2x
  db p_ss
  dw c_fld_bp,x2
  dw c_fmulp
{}
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
  dw c_fld_st
  dw c_frndint
  dw c_fsub_st1
  dw c_fld1
  dw c_fscale
  dw c_fstp_st1
  dw c_fxch
  dw c_f2xm1
  dw c_fld1
  dw c_faddp
  dw c_fmulp
end;

function fSqrn(x1,x2:extended):extended;assembler;
var cw:word;
asm
  dw c_fld1
  db p_ss
  dw c_fld_bp,x1
  dw c_fyl2x
  db p_ss
  dw c_fld_bp,x2
  dw c_fld1
  dw c_fdivrp
  dw c_fmulp
{}
  db p_ss
  dw c_fstcw_bp,cw
  mov ax,cw
  and ax,not cw_rcm
  or ax,0400h
  mov cw,ax
  db p_ss
  dw c_fldcw_bp,cw
  dw c_fld_st
  dw c_frndint
  dw c_fsub_st1
  dw c_fld1
  dw c_fscale
  dw c_fstp_st1
  dw c_fxch
  dw c_f2xm1
  dw c_fld1
  dw c_faddp
  dw c_fmulp
end;

function fRad(x1,x2:extended):extended;assembler;
asm
  db p_ss
  dw c_fld_bp,x1
  dw c_fmul-$100
  db p_ss
  dw c_fld_bp,x2
  dw c_fmul-$100
  dw c_faddp
  dw c_fsqrt
end;

function fGrd2Rad(x1:extended):extended;assembler;
var w:word;
asm
  db p_ss
  dw c_fld_bp,x1
  dw c_fldpi
  dw c_fmulp
  mov w,180d
  dw c_fildw_bp,w
  dw c_fdivp
end;

function fRad2Grd(x1:extended):extended;assembler;
var w:word;
asm
  db p_ss
  dw c_fld_bp,x1
  dw c_fldpi
  dw c_fdivp
  mov w,180d
  dw c_fildw_bp,w
  dw c_fmulp
end;

function fang(x,y:extended):extended;assembler;
asm
  db p_ss
  dw c_fld_bp,y
  db p_ss
  dw c_fld_bp,x
  dw c_ftst
  dw c_fstsw_ax
  mov bx,ax
  dw c_fxch
  dw c_ftst
  dw c_fstsw_ax
  and ah,01000101b
  and bh,01000101b
  dw c_fxch
  mov al,ah
  and al,bh
  cmp al,01000000b
  jne @@l1
{x=0^y=0}
  dw c_fstp_st1-$100
  dw c_fstp_st1-$100
  dw c_fld,_ezero
  jmp @@fin
@@l1:
  cmp bh,01000000b
  jne @@l2
{x=0}
  dw c_fstp_st1-$100
  dw c_fstp_st1-$100
  dw c_fldpi
  dw c_fld,_onehalf
  dw c_fmulp
  cmp ah,1
  je @@l1_1
  jmp @@fin
@@l1_1:
  dw c_fldpi
  dw c_fsubp
  jmp @@fin
@@l2:
  cmp ah,01000000b
  jne @@l3
  dw c_fstp_st1-$100
  dw c_fstp_st1-$100
  cmp bh,1
  je @@l2_1
  dw c_fldz
  jmp @@fin
@@l2_1:
  dw c_fldpi
  jmp @@fin
{y=0}
@@l3:
  mov al,ah
  or al,bh
  jne @@l4
{x>0^y>0}
  dw c_fpatan
  jmp @@fin
@@l4:
  mov al,ah
  and al,bh
  dec al
  jnz @@l5
{x<0^y<0}
  dw c_fpatan
  dw c_fldpi
  dw c_fadd
  dw c_faddp
  jmp @@fin
@@l5:
  or ah,ah
  jne @@l6
{x>0^y<0}
  dw c_fdivp
  dw c_fld1
  dw c_fpatan
  dw c_fldpi
{  dw c_fadd}
  dw c_faddp
  jmp @@fin
@@l6:
{x<0^y>0}
  dw c_fdivp
  dw c_fld1
  dw c_fpatan
  dw c_fldpi
  dw c_fadd
  dw c_faddp
  jmp @@fin
@@fin:
end;

begin
  asm
    fninit;
  end;
  writeln(f_power(+2.0,+3.0000):10:8);
(*  GetTime(h1,m1,s1,c1);
  for i:=1 to 500000 do begin
    x:=exp(10);
  end;
  GetTime(h2,m2,s2,c2);
  if c2<c1 then begin inc(c2,100);dec(s2);end;
  if s2<s1 then begin inc(s2,60);dec(m2);end;
  if m2<m1 then begin inc(m2,60);dec(h2);end;
  writeln('Pas test time: ':40,h2-h1:3,m2-m1:3,s2-s1:3,c2-c1:3);*)
{  writeln('Pas: Ok');}
  GetTime(h1,m1,s1,c1);
  for i:=1 to 500000 do begin
    x:=pardiv(15.2,-10);
  end;
  GetTime(h2,m2,s2,c2);
  if c2<c1 then begin inc(c2,100);dec(s2);end;
  if s2<s1 then begin inc(s2,60);dec(m2);end;
  if m2<m1 then begin inc(m2,60);dec(h2);end;
  writeln('Sys test time: ':40,h2-h1:3,m2-m1:3,s2-s1:3,c2-c1:3);
{  writeln('Sys: Ok');}
  GetTime(h1,m1,s1,c1);
  for i:=1 to 500000 do begin
    x:=f_div(15.2,-10);
  end;
  GetTime(h2,m2,s2,c2);
  if c2<c1 then begin inc(c2,100);dec(s2);end;
  if s2<s1 then begin inc(s2,60);dec(m2);end;
  if m2<m1 then begin inc(m2,60);dec(h2);end;
  writeln('FPU test time: ':40,h2-h1:3,m2-m1:3,s2-s1:3,c2-c1:3);
  writeln(f_power(+3.0,+5.0000):10:8);
  writeln(parpower(+3.0,+5.0000):10:8);
end.
(*{power}
  asm
    dw c_fld1
    dw c_fld,x1
    dw c_fyl2x
    dw c_fld,x2
    dw c_fmulp
    dw c_fstp,x
  end;
  x:=pow2(x);*)
(*  {arctg}
  asm
    dw c_fld,x1
    dw c_fld1
    dw c_fpatan
    dw c_fstp,x
  end;*)
(*  {arcctg}
  asm {It's nessesary to compare x1 with 0}
    dw c_fld1
    dw c_fld,x1
    dw c_fpatan
    dw c_fstp,x
  end;*)
