{$A-,B-,D+,E-,F-,G+,I+,L+,N+,O-,P+,Q+,R+,S+,T+,V-,X+,Y+}
{$M 65520,0,655360}

unit MainForm;

interface

uses
  funcmain,{calculat}{calc_v3}func_ops{,savegr,},mstring,colors256,GraV,
  Objects,Images,cfg,crt,mobj,GrApp,math;

{ᮢ뢠 䨪}
procedure Paint(WS:PGraphView);{ᮢ 䨪}
Procedure InitGrW;
var Img:PLGFImage;

implementation

uses graph;
var
    R:TRect;
    P:TPoint;
    b:byte;
    MyOldExit:pointer;
    vp:ViewPortType;

{$F+}
procedure MyExit;{樠}
var f:text;
begin
  ExitProc:=MyOldExit;
 if ExitCode<>0 then begin
  assign(f,'crash.log');
{$i-}
  append(f);
  if IOResult<>0 then rewrite(f);
{$i+}
  if IOResult=0 then begin
    writeln(f,'Program crashed! (v1.99.4)');
    writeln(f,'Error code        : ',ExitCode);
    writeln(f,'Error addres      : ',{Hex2str}(seg(errorAddr^)),':',{Hex2str}(ofs(errorAddr^)));
    writeln(f,'Compiled function : ',FuncStr);
    writeln(f,'Current settings  :');
    writeln(f,'XScale = ',config.XScale);
    writeln(f,'YScale = ',config.YScale);
    writeln(f,'X0     = ',config.X0);
    writeln(f,'Y0     = ',config.Y0);
    writeln(f,'XStep  = ',config.XStep);
    writeln(f,'IsGrid = ',config.IsGrid);
    writeln(f,'Lang   = ',config.Language);
    writeln(f,'GraphM = ',config.GraphMode);
    writeln(f,'RndMode= ',config.RNDSolid);
    writeln(f,'387    = ',config.Use387);
    writeln(f,'DDraw  = ',config.DDraw);
    writeln(f,'DInit  = ',config.DInit);
    writeln(f,'EZero  = ',config.EZero);
    writeln(f,'Delta  = ',config.Delta);
    writeln(f,'FncMode= ',config.FncMode);
    writeln(f,'PMin   = ',config.PMin);
    writeln(f,'PMax   = ',config.PMax);
    writeln(f,'R0     = ',config.regs[0]);
    writeln(f,'R1     = ',config.regs[1]);
    writeln(f,'R2     = ',config.regs[2]);
    writeln(f,'R3     = ',config.regs[3]);
    writeln(f,'R4     = ',config.regs[4]);
    writeln(f,'R5     = ',config.regs[5]);
    writeln(f,'R6     = ',config.regs[6]);
    writeln(f,'R7     = ',config.regs[7]);
    writeln(f,'R8     = ',config.regs[8]);
    writeln(f,'R9     = ',config.regs[9]);
    writeln(f,'I      = ',_I);
    writeln(f,'--------------------------------------------------------');
    close(f);
  end;
 end;
  dispose(img,done);
end;
{$F-}

Procedure InitGrW;
begin
{  p.x:=fx;
  p.y:=fy;
  New(Img,init(p));}
end;

procedure Paint(WS:PGraphView);

var AY,AX,PX,PY:integer;x,x1,y,y1,t,la,lb:extended;s:string;
   cx,cy:integer;
   i:longint;
   abort:boolean;
   f:PFunction;

function c2x(x:extended):longint;{८ࠧ . न  䨧᪨}
begin
  c2x:=Round((x+AX*PX-config.x0)*FX/2/(AX*PX))+dx;
end;

function c2y(y:extended):longint;
begin
  c2y:=Round((-y+AY*PY+config.y0)/2/(AY*PY)*FY)+dy;
end;

begin
{  WS^.MoveTo(dx,dy);}
  if prepared and (not FError) then begin
    Img^.draw(ws);
    exit;
  end;
  abort:=false;
  p.x:=config.x0;
  p.y:=config.y0;
{  setViewPort}
  GetViewSettings(vp);
  SetViewPort(vp.x1,vp.y1,vp.x2,vp.y2,false);
  if config.IsGrid then b:=ltDot else b:=ltNone;
  if not prepared then
  Img^.ReInit(p,config.XScale,config.YScale,fx,fy,b,
    config.bcol,config.lcol,config.ncol,config.rcol,config.gcol);
  SetWriteMode(NormalPut);
  SetTextJustify(CenterText, CenterText);
  setBkColor(scBlack{GCol});
  setFillStyle(SolidFill,config.BCol);
  R.Assign(dx,dy,fx+2*dx,fY+2*dy);
  ws^.bar(r);
  SetLineStyle(SolidLn,0,1);

  {==============+==============}
  setColor(config.LCol{scBlue});
  ws^.SetCursor(dx,0+dy);
  p.x:=FX+dx;
  p.y:=0+dy;
  ws^.lineto(p);
  p.x:=fx+dx;
  p.y:=fy+dy;
  ws^.lineto(p);
  p.x:=0+dx;
  p.y:=fy+dy;
  ws^.lineto(p);
  p.x:=0+dx;
  p.y:=0+dy;
  ws^.lineTo(p);
  ws^.SetCursor(fx div 2+dx,0+dy);
  p.x:=fx div 2+dx;
  p.y:=fy+dy;
  ws^.lineto(p);
  ws^.SetCursor(0+dx,fy div 2+dy);
  p.x:=fx+dx;
  p.y:=(fy div 2+dy);
  ws^.lineto(p);
  ws^.SetCursor(fx div 2-5+dx,5+dy);
  p.x:=FX div 2+dx;
  p.y:=(0+dy);
  ws^.lineto(p);
  ws^.SetCursor(FX div 2+5+dx,5+dy);
  p.x:=FX div 2+dx;
  p.y:=(0+dy);
  ws^.lineto(p);
  ws^.SetCursor(FX-7+dx,FY div 2-5+dy);
  p.x:=FX-2+dx;
  p.y:=(FY div 2+dy);
  ws^.lineto(p);
  ws^.SetCursor(FX-7+dx,FY div 2+5+dy);
  p.x:=FX-2+dx;
  p.y:=(FY div 2+dy);
  ws^.lineto(p);

  setColor(config.NCol);
  p.x:=FX div 2+5+dx+(TextWidth('Y')div 2)+2;
  p.y:=0+dy+(TextHeight('Y')div 2)+4;
  ws^.WriteTextXY(p,'Y');
  p.x:=FX-10+(TextWidth('X')div 2);
  p.y:=FY div 2+5+dx+dy+(TextHeight('X')div 2);
  ws^.WriteTextXY(p,'X');

  AY:=config.YScale;
  PY:=1;
{  py:=round(exp(round(ln(ay)/ln(10))*ln(10)));}

  while AY>10 do begin AY:=round(AY/10);PY:=PY*10;end;
  if AY<2 then begin
    AY:=3;
  end;
  _ymax:=config.y0+ay*py;
  _ymin:=config.y0-ay*py;

  AX:=config.XScale;
  PX:=1;{ॢ: AX - - 㭪⮢; PX - 祭; AX*PX=MaxX}
  while AX>10 do begin AX:=round(AX/10);PX:=PX*10;end;
  if AX<3 then AX:=3;
  _xmax:=config.x0+ax*px;
  _xmin:=config.x0-ax*px;
{=========⪠=========}
  if config.IsGrid then {⪠}
    SetLineStyle(DottedLn, 0, NormWidth);
  for I := 1 to (AY-1) do begin
    setcolor(config.RCol{127}{Navy});
    if config.IsGrid then begin
      ws^.SetCursor(0+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      ws^.lineTo(p);
    end else begin
      ws^.SetCursor(FX div 2-2+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX div 2+2+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      ws^.lineTo(p);
    end;
    setcolor(config.NCol);
    p.x:=FX div 2+2+dx+(TextWidth(Str2(config.Y0+(AY-i)*PY))div 2)+2;
    p.y:=(FY*i) div (AY*2)+dy+1{+(TextHeight(Str2(Y0+(AY-i)*PY))div 2)};
    ws^.WriteTextXY(p,Str2(config.Y0+(AY-i)*PY));
  end;

  for I := AY+1 to (AY*2-1) do begin
    setcolor(config.RCol);
    if config.IsGrid then begin
      ws^.SetCursor(0+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      ws^.lineTo(p);
    end else begin
      ws^.SetCursor(FX div 2-2+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX div 2+2+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      ws^.lineTo(p);
    end;
    setcolor(config.NCol);
    p.x:=FX div 2+2+dx+(TextWidth(Str2(config.Y0+(AY-i)*PY))div 2)+2;
    p.y:=(FY*i) div (AY*2)+dy+1{+(TextHeight(Str2(Y0+(AY-i)*PY))div 2)};
    ws^.writeTextXY(p,Str2(config.Y0+(AY-i)*PY));
  end;

{  Form1.Cursor:=crHourGlass;}
  for I := 1 to (AX-1) do begin
    setcolor(config.RCol);
    if config.isGrid then begin
      ws^.SetCursor((FX*i) div (AX*2)+dx,0+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY+dy;
      ws^.lineTo(p);
    end else begin
      ws^.SetCursor((FX*i) div (AX*2)+dx,FY div 2-2+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY div 2+2+dy;
      ws^.lineTo(p);
    end;
    setcolor(config.NCol);
    p.x:=(FX*i) div (AX*2)+2+dx;
    p.y:=FY div 2+2+dy+(TextHeight(Str2(config.X0+(AX-i)*PX))div 2)+2;
    ws^.WriteTextXY(p,Str2(config.X0+(-AX+i)*PX));
  end;

  for I := AX+1 to (AX*2-1) do begin
    setcolor(config.RCol);
    if config.isGrid then begin
      ws^.SetCursor((FX*i) div (AX*2)+dx,0+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY+dy;
      ws^.lineTo(p);
    end else begin
      ws^.SetCursor((FX*i) div (AX*2)+dx,FY div 2-2+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY div 2+2+dy;
      ws^.lineTo(p);
    end;
    setcolor(config.NCol);
    p.x:=(FX*i) div (AX*2)+2+dx;
    p.y:=FY div 2+2+dy+(TextHeight(Str2(config.X0+(AX-i)*PX))div 2)+2;
    ws^.WriteTextXY(p,Str2(config.X0+(-AX+i)*PX));
  end;

  setcolor(config.NCol);
  p.x:=FX div 2+1+dx+(TextWidth(Str2(config.X0)+','+Str2(config.Y0))div 2)+2;
  p.y:=FY div 2+1+dy+(TextHeight(Str2(config.X0)+','+Str2(config.Y0))div 2)+3;
  ws^.WriteTextXY(p,Str2(config.X0)+','+Str2(config.Y0));

{=============ᮢ 䨪===============}
  if config.FncMode=PolarMode then la:=config.pmin else
    la:=config.x0-AX*PX;
  if config.FncMode=PolarMode then lb:=config.pmax else
    lb:=config.x0+AX*PX;
  x1:=la;
{    FError:=false;}
{  if CurFunc<>-1 then begin}
  if FError then exit;
  f:=CompileStr(FuncStr);
  if CError or CompValid(f) then exit;
  f^.simple;
  if true{FuncStr<>''} then begin
    SetLineStyle(SolidLn, 0, NormWidth);
    setColor(config.GCol);
{    x1:=config.x0-AX*PX;}
    if not Ferror then begin
{      y1:=calcStr(FuncStr,x1);}
      _i:=0;
      y1:=f^.calculate(x1);
      if (Config.FncMode=PolarMode) and not FuncValid(y1) then begin
        t:=y1*sin(x1);
        x1:=y1*cos(x1);
        if x1<config.x0-AX*PX then x1:=config.x0-AX*PX
          else if x1>config.x0+AX*PX then x1:=config.x0+AX*PX;
        y1:=t;
      end;
    end;
    if FError then exit;
    if (y1>(config.y0+AY*PY))and(not FuncValid(y1)) then y1:=config.y0+AY*PY;
    if (y1<(config.y0-AY*PY))and(not FuncValid(y1)) then y1:=config.y0-AY*PY;
    cx:=c2x(x1);{Round((x1+AX*PX-x0)*FX/2/(AX*PX))+dx;}
    if not FuncValid(y1) then
      cy:=c2y(y1);{Round((-y1+AY*PY+y0)/2/(AY*PY)*FY)+dy;}
    gauge^.SetUp(Round({PX*AX*2}(lb-la)/config.Xstep));
    ws^.SetCursor(cx,cy);
    p.x:=cx;
    p.y:=cy;
    img^.AddPix(cx,cy,lgfGo);
    for i:=1 to Round({PX*AX*2}(lb-la)/config.Xstep) do begin
      _i:=i;
      if (i mod 100)=0 then begin
        gauge^.incr(100);
{        Application^.idle;}
        ws^.SetCursor(p.x,p.y);
      end;
      if {(config.DDraw)and}(keypressed)and(ReadKey=#27) then abort:=true;
      if FError or abort then break;
{      x:=config.X0-AX*PX+i*config.XStep;}
      x:=la+i*config.XStep;
      f^.isSolid:=true;
{      y:=calcStr(FuncStr,x);}
      y:=f^.calculate(x);
      if (Config.FncMode=PolarMode) and not FuncValid(y) then begin
        t:=y*sin(x);
        x:=y*cos(x);
        y:=t;
        if x<config.x0-AX*PX then x:=config.x0-AX*PX
          else if x>config.x0+AX*PX then x:=config.x0+AX*PX;
      end;
      if (y>(config.y0+AY*PY))and(not FuncValid(y)) then y:=config.y0+AY*PY;
      if (y<(config.y0-AY*PY))and(not FuncValid(y)) then y:=config.y0-AY*PY;
      if FuncValid(y){or(abs(y)>(y0+(AY*PY)*11))} then begin
      end else begin
        if (Not f^.IsSolid)or FuncValid(y1) then begin
          p.x:=c2x(x);
          p.y:=c2y(y);
          ws^.SetCursor(p.x,p.y);
          ws^.LineTo(p);
          Img^.addPix(p.x,p.y,lgfGo);
          Img^.addPix(p.x,p.y,lgfDraw);
{          Img^.addPix(p.x,p.y,lgfPoint);}
        end else begin
          p.x:=c2x(x);
          p.y:=c2y(y);
          ws^.LineTo(p);
          Img^.addPix(p.x,p.y,lgfDraw);
        end;
      end;{For}
      x1:=x;
      y1:=y;
    end;{If CurFunc<>-1/FuncStr<>'' }
  end;
  gauge^.incr(100);
{  Application^.idle;}
{    for i:=1 to fy do begin
    end;}
  SetViewPort(vp.x1,vp.y1,vp.x2,vp.y2,vp.clip);
  if not (config.DDraw or abort)then
    prepared:=true;
  if not CompValid(f) then dispose(f,done);
{  Img^.draw(ws);}
end;

begin
  if not config.DDraw then begin {᫨ 祭 ⨬,  ᮧ
     ⥩ 䨪  ࠬࠬ  䠩 䨣樨}
    p.x:=config.x0;
    p.y:=config.y0;
    if config.IsGrid then b:=ltDot else b:=ltNone;
    new(img,init(p,config.XScale,config.YScale,config.wx,config.wx,b,
      config.bcol,config.lcol,config.ncol,config.rcol,config.gcol));
    myOldExit:=ExitProc;
    exitProc:=@MyExit;{⠭ 楤 樠樨}
  end else img:=new(PLGFStub,SInit);{ 砥 DDraw ᮧ }
  prepared:=false;{ ⮢-⮦ ⠪?}
end.
