unit math;
interface

function IMin(a,b:longint):longint;
function RMin(a,b:extended):extended;
function IMax(a,b:longint):longint;
function RMax(a,b:extended):extended;
function Hex2Str(l:longint):string;
function bin2hex(s:string):byte;
function hex2bin(b:longint):string;

implementation

function bin2hex(s:string):byte;
var i,j:word;
begin
  j:=0;
  for i:=length(s) downto 1 do
    begin
      j:=j shl 1;
      if s[length(s)-i+1]='1' then j:=j+1;
    end;
  bin2hex:=byte(j);
end;

function hex2bin(b:longint):string;
var s:string;
begin
  s:='';
  while b>0 do
    begin
      if (b and 1)=1 then s:='1'+s else s:='0'+s;
      b:=b shr 1;
    end;
  if s='' then s:='0';
  hex2bin:=s;
end;


function Hex2Str(l:longint):string;
var i:integer;st:string[9];
const s:string[16]='0123456789ABCDEF';
begin
  st:='';
  while l<>0 do begin
    st:=s[(l mod $10)+1]+st;
    l:=l shr 4;
  end;
  if st='' then st:='0';
  st:=st+'h';
  Hex2Str:=st;
end;

function IMin(a,b:longint):longint;
begin
  If a>b then IMin:=b else IMin:=a;
end;

function RMin(a,b:extended):extended;
begin
  If a>b then RMin:=b else RMin:=a;
end;

function IMax(a,b:longint):longint;
begin
  If a<b then IMax:=b else IMax:=a;
end;

function RMax(a,b:extended):extended;
begin
  If a<b then RMax:=b else RMax:=a;
end;

end.