{Define NORES}
unit cfg;
interface
uses Colors256,mstring,objects;

const IniName='Func.cfg';{ 䨣樮 䠩}
      Rus=0;
      Eng=1;
      Res640x480x16=0;
      Res640x480x256=1;
      Res800x600x256=2;
      Res1024x768x256=3;
      LangStr:array[0..1]of string[3]=('Rus','Eng');
      PName='Functions for DOS!'#0;{   Win95/98}
{      dinit:boolean=true;{ 樠 䨪}
      drvname:string[30]='videodr';{䠩 ࠩ SVGA ०}
      CartesianMode=0;
      PolarMode=1;

type
  TIniRecord=record
    XScale,YScale:Integer;{᪨ ࠧ }
    X0,Y0:integer;{. 業}
    XStep:extended;{蠣  ⮢}
    IsGrid:boolean;{稥 ⪨}
    WX,WY:integer;{ - ⠭  ணࠬ}
    BCol,GCol,NCol,RCol,LCol:word;{ :䮭,䨪,,ࠧa,}
    Language:byte;{ 䥩}
    GraphMode:byte;{ . ०}
    RndSolid:boolean;{뢭 㭪樨 RND}
    Use387:boolean;{ᯮ짮 ᮯ 387}
    DDraw:boolean;{⪫祭 ⨬樨}
    DInit:boolean;{  樠}
    EZero,Delta:extended;{NaN  ~0}
    FncMode:byte;
    pmin,pmax:extended;
      {Polar Minimum and Polar Maximum}

    regs:array[0..9]of extended;
      {0..9 - Free regs}
  end;

var Config:TIniRecord;{ - 䨣}
    CfgFile:file of TIniRecord;
    ps:string;
    i:integer;
    ResStream : PBufStream;
    ResFile   : PResourceFile;
    msgs      : PStringList;

procedure SetDefault;{⠭ "᪨" ⠭}
procedure ReadSettings;{ 䨣  䠩}
procedure SaveSettings;{࠭ 䨣  䠩}

implementation

procedure SetName(const s:string);assembler;
asm{楤 - ⠭    Win95/98, ஢ 稥 Win}
  mov ax,160Ah
  int 2Fh
  or ax,ax
  jne @@fin
  cmp bh,4
  jb @@fin
  mov ax,168eh
  mov dx,0
  les di,s
  inc di
  int 2Fh
@@fin:
end;

procedure SetDefault;
begin
  with config do begin
    x0:=0;
    y0:=0;
    XScale:=10;
    YScale:=10;
    XStep:=0.002;
    IsGrid:=true;
    WX:=600;
    WY:=450;
    BCol:=scWhite;
    GCol:=scBlack;
    NCol:=scBlue;
    RCol:=scCyan;
    LCol:=scLightBlue;
    Language:=Eng;
    GraphMode:=Res640x480x16;{Res800x600x256;}
    RndSolid:=false;
    Use387:=false;
    DDraw:=true;
    DInit:=true;
    EZero:=0.001995;
    Delta:=0.001995;
    FncMode:=CartesianMode;
    pmin:=0;
    pmax:=2*pi;
    regs[0]:=0;
    regs[1]:=0;
    regs[2]:=0;
    regs[3]:=0;
    regs[4]:=0;
    regs[5]:=0;
    regs[6]:=0;
    regs[7]:=0;
    regs[8]:=0;
    regs[9]:=0;
  end;
end;

procedure ReadSettings;
begin
  {$I-}
  assign(CfgFile,IniName);
  FileMode:=0;
  reset(CfgFile);
  if IOresult<>0 then begin
    SetDefault;
    exit;
  end;
  read(CfgFile,Config);
  if IOresult<>0 then begin
    SetDefault;
    exit;
  end;
  close(CfgFile);
  if IOresult<>0 then;
  {$I+}
end;

procedure SaveSettings;
begin
  assign(CfgFile,IniName);
  rewrite(CfgFile);
  write(CfgFile,Config);
  close(CfgFile);
end;

{begin
  SetDefault;
  SaveSettings;}
{  ReadSettings;}
begin
{$IFNDEF NORES}
  RegisterType(RStringList);
  new(ResStream,init('Objects.res',stOpenRead,2048));
  if ResStream^.Status<>0 then begin
    writeln('Error opening resourse file!');
  end;
  new(ResFile,init(ResStream));
{$ENDIF}
  ReadSettings;
{$IFNDEF NORES}
  PObject(msgs):=ResFile^.Get('Msgs'+LangStr[config.language]);
  setName(pname);
  ps:='';
  for i:=1 to ParamCount do ps:=ps+ParamStr(i);
  ps:=UpString(ps);
  i:=Pos('/DINIT',ps);
  if i<>0 then
    if copy(ps,i+6,1)='-' then config.DInit:=false else config.DInit:=true;
  i:=Pos('/RND',ps);
  if i<>0 then
    if copy(ps,i+4,1)='-' then config.RNDSolid:=false else config.RNDSolid:=true;
{$ENDIF}
end.