program Func_gv;
{$M 34000,0,655360}
{$X+,D+}
{$Define DEBUG}
{$Undef NORES}
uses {Dos,}Crt,LowGraph,GFonts,Graph,Objects,{ExtObj,}EventMan,
     Memory,GraV,Controls,GraMenu,Grapp,MsgBox,GStdDlg,Gadgets,
     GrDriver,Images,{Xms,}mainform,{calculat}{Calc_v3,}funcmain,{mstring,}
     cfg,validate,MObj,histList{,deriv2},func_ops{,histCtrl};
type
   GMyApp = object(GraphApplication)
{$IfDef DEBUG}
      Heap : PHeapView;
{$Endif}
      Clock : PClockView;
      constructor Init;
      procedure Idle; virtual;
      procedure HandleEvent(var Event : TEvent); virtual;
      procedure InitMenuBar; virtual;
      procedure InitStatusLine; virtual;
      procedure LoadFonts;virtual;
   end;

  PAboutPane = ^AboutPane;
  AboutPane = object(GraphView)
     constructor Init(Bounds : TRect);
     procedure Draw; virtual;
  end;

  PFuncWnd = ^TFuncWnd;
  TFuncWnd = object(GraphWindow)
     constructor Init(var Bounds : TRect);
{     procedure Draw; virtual;}
  end;

  PInterior = ^TInterior;
  TInterior = object(GraphView)
{    constructor Init(var Bounds: TRect);}
 {   destructor Done; virtual;}
    procedure Draw; virtual;
  end;

  PMValid=^MValid;
  MValid=object(TRangeValidator)
           procedure Error;virtual;
{           function IsValid(const S: string): Boolean; virtual;}
{           function IsValidInput(var S: string;
             SuppressFill: Boolean): Boolean;virtual;}
         end;

  PMValid2=^MValid2;
  MValid2=object(MValid)
           x_1,x_2:extended;
           constructor Init(AMin, AMax: Extended);
           function IsValid(const S: string): Boolean;virtual;
           function Transfer(var S: String; Buffer: Pointer;
             Flag: TVTransfer): Word;virtual;
{           function IsValid(const S: string): Boolean; virtual;}
{           function IsValidInput(var S: string;
             SuppressFill: Boolean): Boolean;virtual;}
         end;

const
  MaxLines          = 100;
  WinCount: Integer =   0;
  HeapSize = 250 * (1024 div 16);

var
{  LineCount: Integer;
  Lines: array[0..MaxLines - 1] of PString;}
  CurStr:string;
var
{   S : String;}
{   StrColl : TStringCollection;}
{   Palette : word;}
   FWnd:PFuncWnd;

{const
   WinNum : word = 0;}

const
  cmNewWin        = 255;  cmConfirm       = 254;  cmInfo          = 253;
  cmError         = 252;  cmWarning       = 251; { cmSavePic       = 250;}
  cmSaveLst       = 249;  cmLoadLst       = 248;  cmPrint         = 247;
  cmInput         = 246;  cmCalc          = 245;  cmPrz           = 244;
  cmOptions       = 243;  cmSaveBmp       = 242;  cmSavePcx       = 241;
  cmSaveLgf       = 240;  cmAbout         = 239;  cmIntegr        = 238;
  cmRegs          = 237;
{  cmHelp          = 242;}


  cmNothing       = $FFFF;

  hcNewWin        = 1255;  hcConfirm       = 1254;  hcInfo          = 1253;
  hcError         = 1252;  hcWarning       = 1251; { hcSavePic       = 1250;}
  hcSaveLst       = 1249;  hcLoadLst       = 1248;  hcPrint         = 1247;
  hcInput         = 1246;  hcCalc          = 1245;  hcPrz           = 1244;
  hcOptions       = 1243;  hcAbout         = 1241;  hcSaveBmp       = 1240;
  hcSavePcx       = 1239;  hcSaveLgf       = 1238;  hcIntegr        = 1237;
  hcRegs          = 1236;

  strAbout1 = 0;
  strAbout2 = 1;
  strAbout3 = 2;
  strAbout4 = 3;
  strAbout5 = 4;

  strCalc   = 6;
  strXStep  = 7;
  strPMin   = 8;
  strPMax   = 9;
  strCart   = 10;
  strPolar  = 11;
  strCoord  = 12;
  strGrid   = 13;

  strAbout  = 16;
  strFunc   = 17;
  strCalcul = 18;
  strIntegr = 19;
  strOpt    = 20;
  strRegs   = 21;

  strSBMP   = 32;
  strSLGF   = 33;
  strSPCX   = 34;
  strSFL    = 35;
  strLFL    = 36;
  strInpF   = 37;
  strBadI   = 38;
  strE_DF   = 39;
  strError  = 40;
  strE_LD   = 41;
  strE_CCD  = 42;
  strTDIs   = 43;
  strUseF   = 44;

  strEUF    = 46;
  strEEBE   = 47;
  strEEE    = 48;
  strESE    = 49;
  strECE    = 50;
  strEBBE   = 51;

  cInpHist=1;
  cNumHist=2;
{  cmHelp          = 242;}

  prVer='1.99.4';

var
  MyApp : GMyApp;
{  A : PGraphView;
  F : PGraphWindow;
  D : GraphGroup;}
{  R,R1 : TRect;}
  MaxX, MaxY  : word;     { The maximum resolution of the screen }
  ErrorCode   : integer;  { Reports any graphics errors }
  MaxColor    : word;     { The maximum color value available }
  OldExitProc : Pointer;  { Saves exit procedure address }
{  PathToDriver : string;}
  Ch : Char;
  i : integer;

{  r:TRect;
  p :PGraphStaticBitmap;
  p1:PBufStream;}

procedure About;forward;
procedure NewWin{(Ev:TEvent)};forward;
procedure DoError;forward;
{procedure SavePic;forward;}
procedure SaveBmp;forward;
procedure SavePcx;forward;
procedure SaveLgf;forward;
procedure SaveLst;forward;
procedure LoadLst;forward;
procedure Print;forward;
procedure Input;forward;
procedure DoCalc;forward;
procedure DoPrz;forward;
procedure DoOptions;forward;
procedure DoIntegr;forward;
procedure Help;forward;
procedure DoRegs;forward;

constructor GMyApp.Init;
var
   R : TRect;
begin
{$IfDef DEBUG}
   MaxHeapSize := HeapSize;
{$EndIf}
   GraphApplication.Init;
   Config.wx:=((GetMaxX)*3) div 4;
   Config.wy:=((GetMaxY)*3) div 4;
   GetExtent(R);
   LoadFonts;
   R.A.X := R.B.X - 74;
   inc(R.A.Y);
   R.B.Y := R.A.Y + 14;
   Clock := New(PClockView,Init(R));
   Insert(Clock);
{$IfDef DEBUG}
   GetExtent(R);
   dec(R.B.Y,2);
   R.A.Y := R.B.Y - 14;
   R.A.X := R.B.X - 74;
   dec(R.B.X,2);
   Gauge:= New(PGauge,Init(R));
   Insert(Gauge);
{$EndIf}
   DisableCommands([cmPrint,{cmPrz,}{cmCalc,}cmHelp]);
   newWin;
end;

procedure GMyApp.LoadFonts;
begin
  dispose(PFont(Fonts^.items^[1]),done);
  Fonts^.items^[1]:=ResFile^.get('Font8x8');
  dispose(PFont(Fonts^.items^[2]),done);
  Fonts^.items^[2]:=ResFile^.get('Font8x14');
  dispose(PFont(Fonts^.items^[3]),done);
  Fonts^.items^[3]:=ResFile^.get('Font8x16');
end;

procedure GMyApp.Idle;

function IsTileable(P: PGraphView): Boolean; far;
begin
  IsTileable := P^.Options and ofTileable <> 0;
end;

begin
  GraphApplication.Idle;
  Clock^.Update;
{$IfDef DEBUG}
{  Heap^.Update;}
  Gauge^.Update;
{$EndIf}
{  Message(DeskTop,evBroadcast,cmIdle,nil);}
end;


procedure GMyApp.InitMenuBar;
var R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + MenuItemHeight;
  MenuBar := PGraphMenuBar(ResFile^.get('MenuBar'+LangStr[config.language]));
  MenuBar^.SetBounds(r);
{  MenuBar}
end;

procedure GMyApp.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - StatusItemHeight;
  StatusLine := PGraphStatusLine(ResFile^.get('StatusLine'+
    LangStr[config.language]));
  StatusLine^.SetBounds(r);
  {StatusLine}
end;

procedure GMyApp.HandleEvent(var Event : TEvent);
var
   R : TRect;
   R1,R2 : TRect;
   W : word;
   Wnd,Child : PGraphWindow;
const
   b:Boolean=false;

begin
  GraphApplication.HandleEvent(Event);
  case Event.What of
    evCommand:
      case Event.Command of
{        cmOpen: FileOpen;}
{        cmNew: FileNew;}
{        cmDosShell: DosShell;}
{        cmShowClip: ShowClip;}
        cmTile: Tile;
{        cmCalculator: Calculator;}
        cmCascade: Cascade;
{        cmPuzzle: Puzzle;}
{        cmArty : Arty;}
        cmAbout : About;
{        cmCircles : Circles;}
{        cmShowImage : ShowImage;}
{        cmChangeMemView : ChangeMemViewer;}
        cmNewWin:NewWin{(Event)};
        cmError:DoError;
{        cmSavePic:SavePic;}
        cmSavePcx:SavePcx;
        cmSaveBmp:SaveBmp;
        cmSaveLgf:SaveLgf;
        cmSaveLst:SaveLst;
        cmLoadLst:LoadLst;
        cmPrint:Print;
        cmInput:Input;
        cmCalc:DoCalc;
        cmPrz:DoPrz;
        cmOptions:DoOptions;
        cmIntegr:DoIntegr;
        cmRegs:DoRegs;
{        cmMenuBar:
          begin
            b:=FError;
            FError:=true;
          end;
        cmNoMenuBar:
          begin
            FError:=b;
            FWnd^.draw;
          end;}
{        cmHelp:Help;}
      else
        Exit;
      end;
  else
    Exit;
  end;
  ClearEvent(Event);
end;

constructor AboutPane.Init(Bounds : TRect);
begin
   GraphView.Init(Bounds);
end;

procedure AboutPane.Draw;
var
   R : TRect;
   P : TPoint;
begin
   GetExtent(R);
   SetFillStyle(SolidFill,GetColor(1));
   Bar(R);

   GFonts.SetTextStyle(3,HorizDir,1);
   Fillbackground := false;
   SetColor(DarkGray);
   P.X := 110;
   P.Y := 08;
{   WriteTextXY(P,'Functions'#$f9#$fa' v'+prVer);}
   WriteTextXY(P,'Functions'#$ff' v'+prVer);
   dec(P.X);
   dec(P.Y);
   SetColor(Blue);
   WritetextXY(P,'Functions  v'+prVer);
   FillBackground := true;
   GFonts.SetTextStyle(2,HorizDir,1);
   P.X := 0;
   inc(P.Y,20);
   SetFillStyle(SolidFill,GetColor(1));
   SetColor(Black);
   WriteTextXY(P,Msgs^.Get(strAbout1){'Written by Fomin Pavel.1999.Ivanovo,Russia.'});
   inc(P.Y,17);
{   P.X := 100;}
   WriteTextXY(P,Msgs^.Get(strAbout2){'Fomin Pavel AKA Pasha 1st AKA 2:5026/45.13'});
   inc(p.y,17);
   WriteTextXY(P,Msgs^.Get(strAbout3){'All rights are fiction.'});

   inc(P.Y,17);
{   P.X := 100;}
   WriteTextXY(P,Msgs^.Get(strAbout4){'Phone: no, no, you can''t find me :].'});
   inc(P.Y,17);
{   P.X := 80;}
   WriteTextXY(P,Msgs^.Get(strAbout5){'Used: Graphic Vision, Borland Pascal v7.0.'});
end;

procedure About;
var
   D : PGraphDialog;
   R : TRect;
   P : PGraphView;
   b:boolean;
begin
  R.Assign(0, 0, 401, 270);
  b:=FError;
  FError:=true;
  R.Move((Desktop^.Size.X - R.B.X) div 2, (Desktop^.Size.Y - R.B.Y) div 2);
  D := New(PGraphDialog,Init(R,Msgs^.Get(strAbout){'About'}));
  with D^ do begin
     R.Assign(14,13,375,177);
     Insert(New(PGraphGrayGroup,Init(R)));
     R.Assign(28,26,368,164);
     Insert(New(PAboutPane,Init(R)));
     R.Assign(162,194,225,233);
     P := New(PGraphBitmapButton,Init(R,'O~K~',cmOk,bfNormal));
     Insert(P);
     r.assign(15,134,375,176);
     if GetMaxColor=15 then
       Insert(New(PMyStatImg,Init(R,'ML4',resFile)))
{       Insert(PGraphView(resFile^.get('ML4')))}
     else
       Insert(New(PMyStatImg,Init(R,'ML8',resFile)));
{       Insert(New(PGraphStaticBitmap,Init(R,'ML')));}
     SelectNext(false);
  end;
   DeskTop^.ExecView(D);
   Dispose(D,Done);
   FError:=b;
   FWnd^.drawView;
end;

procedure NewWin{(Ev:TEvent)};
var r:TRect;
begin
  r.assign(0,0,config.wx,config.wy);
  R.Move((Desktop^.Size.X - R.B.X) div 2, (Desktop^.Size.Y - R.B.Y) div 2);
  new(FWnd,init(r));
  inc(WinCount);
  DeskTop^.insert(FWnd);
end;

procedure DoError;
begin
end;

procedure SaveBmp;
var r:TRect;
    wnd:PFileDialog;
    Control: Word;
    p:pointer;
    FN:string;{file name}
begin
  wnd:=New(PFileDialog, Init('*.bmp', Msgs^.Get(strSBMP){'Save as a bitmap file'},
      '~Name', fdOkButton{ + fdHelpButton}, 2));

  Control := DeskTop^.ExecView(Wnd);
  Wnd^.GetFileName(fn);
  dispose(wnd,done);
  if control<>cmCancel then begin
    if fn<>'' then begin
      r.assign(0,0,FWnd^.size.x,FWnd^.size.y{config.wx,config.wy});
      R.Move((Desktop^.Size.X-R.B.X) div 2,(Desktop^.Size.Y -R.B.Y)div 2+16);
{      dec(R.a.y,64);}
{      r.a.y:=0;}
{      FWnd^.draw;}
      WriteScrBmp(r,fn);
    end;
  end;{ else begin
    FError:=b;
    FWnd^.draw;
  end;}
end;

procedure SaveLgf;
var r:TRect;
    wnd:PFileDialog;
    Control: Word;
    p:pointer;
    FN:string;{file name}
begin
{  R.Assign(000,000,500,120);
  R.Move((GetMaxX-(r.b.x-r.a.x))div 2,(GetMaxY-(r.b.y-r.a.y))div 2);}
{  wnd:=new(PGraphDialog,init(r,'Input file name'));}
  if not prepared then exit;
  wnd:=New(PFileDialog, Init('*.lgf',Msgs^.Get(strSLGF){ 'Save as a .lgf file'},
      '~N~ame', fdOkButton{ + fdHelpButton}, 2));

  Control := DeskTop^.ExecView(Wnd);
  Wnd^.GetFileName(fn);
  dispose(wnd,done);
  if control<>cmCancel then begin
    if fn<>'' then begin
      r.assign(0,0,FWnd^.size.x,FWnd^.size.y{config.wx,config.wy});
      R.Move((Desktop^.Size.X-R.B.X) div 2,(Desktop^.Size.Y -R.B.Y)div 2+16);
{      dec(R.a.y,64);}
{      r.a.y:=0;}
{      FWnd^.draw;}
      img^.SaveTo(fn,FuncStr);
    end;
  end;{ else begin
    FError:=b;
    FWnd^.draw;
  end;}
end;

procedure SavePcx;
var r:TRect;
    wnd:PFileDialog;
    Control: Word;
    p:pointer;
    FN:string;{file name}
begin
{  R.Assign(000,000,500,120);
  R.Move((GetMaxX-(r.b.x-r.a.x))div 2,(GetMaxY-(r.b.y-r.a.y))div 2);}
{  wnd:=new(PGraphDialog,init(r,'Input file name'));}
  wnd:=New(PFileDialog, Init('*.pcx',Msgs^.Get(strSPCX){ 'Save as a .pcx file'},
      '~N~ame', fdOkButton{ + fdHelpButton}, 2));

  Control := DeskTop^.ExecView(Wnd);
  Wnd^.GetFileName(fn);
  dispose(wnd,done);
  if control<>cmCancel then begin
    if fn<>'' then begin
      r.assign(0,0,FWnd^.size.x,FWnd^.size.y{config.wx,config.wy});
      R.Move((Desktop^.Size.X-R.B.X) div 2,(Desktop^.Size.Y -R.B.Y)div 2+16);
{      dec(R.a.y,64);}
{      r.a.y:=0;}
{      FWnd^.draw;}
      WriteScrPcx(r,fn);
    end;
  end;{ else begin
    FError:=b;
    FWnd^.draw;
  end;}
end;

procedure SaveLst;
var {r:TRect;}
    wnd:PFileDialog;
    Control: Word;
    p:pointer;
    FN:string;{file name}
    i:integer;
    f:text;
begin
  wnd:=New(PFileDialog, Init('*.lst',Msgs^.Get(strSFL){ 'Save functions list'},
      '~N~ame', fdOkButton{ + fdHelpButton}, 3));

  Control := DeskTop^.ExecView(Wnd);
  Wnd^.GetFileName(fn);
  dispose(wnd,done);
  if control<>cmCancel then begin
    if fn<>'' then begin
      assign(f,fn);
      rewrite(f);
      for i:=1 to HistoryCount(cInpHist) do
        writeln(f,HistoryStr(cInpHist,i-1));
      close(f);
    end;
  end;
end;

procedure LoadLst;
var {r:TRect;}
    wnd:PFileDialog;
    Control: Word;
    p:pointer;
    FN,s:string;{file name}
    i:integer;
    f:text;
begin
  wnd:=New(PFileDialog, Init('*.lst',Msgs^.Get(strLFL){ 'Add functions from file to list'},
      '~N~ame', fdOkButton{ + fdHelpButton}, 3));

  Control := DeskTop^.ExecView(Wnd);
  Wnd^.GetFileName(fn);
  dispose(wnd,done);
  if control<>cmCancel then begin
    if fn<>'' then begin
      assign(f,fn);
      fileMode:=0;
      reset(f);
      while not eof(f) do begin
        readln(f,s);
        HistoryAdd(cInpHist,s);
      end;
      close(f);
    end;
  end;
end;

procedure Print;
begin
end;

procedure Input;
var r:TRect;
    wnd:PGraphDialog;
    Control: Word;
    p:pointer;
    b:boolean;
begin
  R.Assign(000,000,500,120);
  R.Move((GetMaxX-(r.b.x-r.a.x))div 2,(GetMaxY-(r.b.y-r.a.y))div 2);
  wnd:=new(PGraphDialog,init(r,Msgs^.Get(strInpF){'Input function'}));
  with wnd^ do begin
    r.assign(150,050,213,089);
    Insert(new(PGraphBitmapButton,Init(r,'OK',cmOK,bfDefault)));
    r.assign(287,050,350,089);
    insert(New(PGraphBitmapButton,Init(R,'CANCEL',cmCancel,bfNormal)));
    R.Assign(71,020,450,041);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-3,-3);
    r.move(1,1);
    dec(R.B.X,15);
    p:=New(PGraphInputLine,Init(R,240));
    Insert(p);
    R.A.X := R.B.X;
    inc(r.b.x,14);
    R.Move(-1,1);
    Wnd^.Insert(New(PGraphHistory,Init(R,p,cInpHist)));
    R.Assign(30, 023, 69, 037);
    Insert(New(PGraphLabel, Init(R, '~F~(x)=', p)));
    setData(CurStr);
  end;
  b:=FError;
  FError:=True;
  Control := DeskTop^.ExecView(Wnd);
  if control=cmOk then begin
    Wnd^.getData(CurStr);
    DisposeStr(FWnd^.Title);
    if CurStr<>'' then
      FWnd^.Title:=NewStr(Msgs^.Get(strFunc)+{'Functions'}+': F(x)='+CurStr) else
      FWnd^.Title:=NewStr(Msgs^.Get(strFunc)+'.'{'Functions.'});
    FuncStr:=CurStr;
    prepare(FuncStr);
    FError:=false;
    CheckFunc(FuncStr);
    prepared:=false;
    FWnd^.drawView;
  end else begin
    FError:=b;
    FWnd^.drawView;
  end;
  dispose(wnd,done);
end;

procedure DoCalc;
var r:TRect;
    wnd:PGraphDialog;
    Control: Word;
    Ln:PGraphInputLine;
    p1,p2:pointer;
{    i:integer;
    b:boolean;}
    st,st1:string;
    x:extended;

begin
  if FError then exit;
  R.Assign(000,000,500,150);
  R.Move((GetMaxX-(r.b.x-r.a.x))div 2,(GetMaxY-(r.b.y-r.a.y))div 2);
  wnd:=new(PGraphDialog,init(r,Msgs^.Get(strCalcul){'Calculation'}));
  if wnd=nil then exit;{LowMemory}
  st:='0';
  with wnd^ do begin
    r.assign(130,080,193,119);
    Insert(new(PGraphBitmapButton,Init(r,'OK',cmOK,bfNormal)));
    r.assign(277,080,360,119);
    insert(New(PGraphTextButton,Init(R,Msgs^.Get(strCalc){'~C~alculate'},cmYes,bfDefault)));
    R.Assign(71,020,450,041);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-3,-3);
    r.move(1,1);
    p1:=New(PGraphInputLine,Init(R,240));
    Insert(p1);
    R.Assign(54, 023, 69, 037);
    Insert(New(PGraphLabel, Init(R, '~X~=', p1)));
    R.Assign(30, 048, 470, 062);
    p1:=New(PGraphStaticText, Init(R, 'F(x)=...',CurrentFont,0));
    R.Assign(30, 064, 470, 078);
    Insert(p1);
    p2:=New(PGraphStaticText, Init(R, 'F(x)=...',CurrentFont,0));
    Insert(p2);
    setData(St);
  end;
  repeat
    Wnd^.GetData(st);
    prepare(st);
    checkFunc(st);
    if FError then begin
      FError:=false;
      x:=config.EZero;
    end else
    x:=calcStr(st,config.EZero);
{    str(x:20:10,st1);}
    st1:=SimpleNum(x);
    disposeStr(PGraphStaticText(p1)^.text);
    disposeStr(PGraphStaticText(p2)^.text);
    if FuncValid(x) then begin
      PGraphStaticText(p1)^.text:=NewStr(Msgs^.Get(strBadI){'Bad input value'});
      PGraphStaticText(p2)^.text:=NewStr('')
    end
      else begin
        PGraphStaticText(p2)^.text:=NewStr('X   ='+st1);
        x:=calcStr(FuncStr,x);
        if FuncValid(x) then st1:=Msgs^.Get(strE_DF){'X isn''t in D(F)'} else begin
{          str(x:20:10,st1);}
          st1:='F(x)='+SimpleNum(x);
        end;
        PGraphStaticText(p1)^.text:=NewStr(st1);
      end;
    PGraphStaticText(p1)^.DrawView;
    PGraphStaticText(p2)^.DrawView;
    FError:=True;
    Control := DeskTop^.ExecView(Wnd);
    FError:=False;
  until (control=cmOk)or(control=cmCancel);
  FWnd^.drawView;
end;

procedure DoIntegr;
type IntgrRec=record
       s1,s2:string[240];
     end;

var r:TRect;
    wnd:PGraphDialog;
    Control: Word;
    Ln1,ln2:PGraphInputLine;
    p1,p2,p3:pointer;
{    i:integer;
    b:boolean;}
    st,st1,st2:string;
    x1,x2:extended;
    res:IntgrRec;

begin
  if FError then exit;
  R.Assign(000,000,500,200);
  R.Move((GetMaxX-(r.b.x-r.a.x))div 2,(GetMaxY-(r.b.y-r.a.y))div 2);
  wnd:=new(PGraphDialog,init(r,Msgs^.Get(strIntegr){'Integrals'}));
  if wnd=nil then exit;{LowMemory}
  res.s1:='0';
  res.s2:='0';
  with wnd^ do begin
    r.assign(130,130,193,169);
    Insert(new(PGraphBitmapButton,Init(r,'OK',cmOK,bfNormal)));
    r.assign(277,130,360,169);
    insert(New(PGraphTextButton,Init(R,Msgs^.Get(strCalc){'~C~alculate'},cmYes,bfDefault)));
    R.Assign(71,020,450,041);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-3,-3);
    r.move(1,1);
    p1:=New(PGraphInputLine,Init(R,240));
    Insert(p1);
    R.Assign(45, 023, 69, 037);
    Insert(new(PGraphLabel, Init(R, 'X~2~=', p1)));

    R.Assign(71,050,450,071);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-3,-3);
    r.move(1,1);
    p2:=New(PGraphInputLine,Init(R,240));
    Insert(p2);
    R.Assign(45, 053, 69, 067);
    Insert(New(PGraphLabel, Init(R, 'X~1~=', p2)));

    PGraphInputLine(p1)^.focus;

    R.Assign(30, 078, 470, 092);
    p1:=New(PGraphStaticText, Init(R, 'F(x)=...',{CurrentFont}2,3));
    Insert(p1);
    R.Assign(30, 094, 470, 108);
    p2:=New(PGraphStaticText, Init(R, 'F(x)=...',{CurrentFont}2,3));
    Insert(p2);
    R.Assign(30, 110, 470, 125);
    p3:=New(PGraphStaticText, Init(R, 'F(x)=...',{CurrentFont}2,3));
    Insert(p3);
    setData(res);
  end;
  repeat
    Wnd^.GetData(res);
    st:=res.s1;
    st1:=res.s2;
    prepare(st);
    prepare(st1);
    checkFunc(st);
    if FError then begin
      FError:=false;
      x1:=config.EZero;
    end else begin
      x1:=calcStr(st,config.EZero);
      checkFunc(st1);
      if FError then begin
        FError:=false;
        x2:=config.EZero;
      end else
        x2:=calcStr(st1,config.EZero);
    end;
    str(x1:20:10,st1);
    str(x2:20:10,st2);
    disposeStr(PGraphStaticText(p1)^.text);
    disposeStr(PGraphStaticText(p2)^.text);
    disposeStr(PGraphStaticText(p3)^.text);
    if FuncValid(x1)or FuncValid(x2) then begin
      PGraphStaticText(p1)^.text:=NewStr(Msgs^.Get(strBadI){'Bad input value'});
      PGraphStaticText(p2)^.text:=NewStr('');
      PGraphStaticText(p3)^.text:=NewStr('');
    end
      else begin
        PGraphStaticText(p1)^.text:=NewStr('X2   ='+st1);
        PGraphStaticText(p3)^.text:=NewStr('X1   ='+st2);
        x1:=Integr(FuncStr,x2,x1);
        if FuncValid(x1) then st1:=Msgs^.Get(strError){'Error!'} else begin
          str(x1:20:10,st1);
          st1:='F(x)='+st1;
        end;
        PGraphStaticText(p2)^.text:=NewStr(st1);
      end;
{    PGraphStaticText(p1)^.Draw;
    PGraphStaticText(p2)^.Draw;
    PGraphStaticText(p3)^.Draw;}
    FError:=True;
    Control := DeskTop^.ExecView(Wnd);
    FError:=False;
  until (control=cmOk)or(control=cmCancel);
  FWnd^.drawView;
end;

procedure DoPrz;
var s:string;
    w:word;
    f:PFunction;
begin
  if FError then exit;
  s:=funcStr;
  DisableWarnings:=true;
  s:=CalcDeriv(s);
  DisableWarnings:=false;
  if DerValid(s)or DError then begin
    if DError then
      MessageBox(Msgs^.Get(strE_LD){'Error! Derivative is too long!'},nil,mfError or mfOkButton) else
      MessageBox(Msgs^.Get(strE_CCD){'Cannot calculate the derivative!'},nil,mfWarning or mfOkButton);
    exit;
  end;
  DisableWarnings:=true;
  CheckFunc(s);
  DisableWarnings:=false;
  if FError then begin
    MessageBox(Msgs^.Get(strE_LD){'Error! Derivative is too long!'},nil,mfError or mfOkButton);
    FError:=false;
    FWnd^.drawview;
    exit;
  end;

  f:=CompileStr(s);
  f^.simple;
  s:=f^.GetName;
  dispose(f,done);
  s:=fsimple(s);
{  r.assign(0,0,420,240);}
  begin
    FError:=true;
    w:=MessageBox(Msgs^.Get(strTDIs){'The derivative is '}+s+
      #13+Msgs^.Get(strUseF){'Use as a function?'},nil,mfConfirmation or {mfOkCancel}
        mfYesNoCancel);
    ferror:=false;
    case w of
      cmYes:
        begin
          HistoryAdd(cInpHist,s);
          DisposeStr(FWnd^.Title);
          CurStr:=s;
          FWnd^.Title:=NewStr(Msgs^.Get(strFunc){'Functions}+': F(x)='+CurStr);
          FuncStr:=CurStr;
          prepare(FuncStr);
          FError:=false;
          CheckFunc(FuncStr);
          prepared:=false;
        end;
      cmNo:
        begin
          HistoryAdd(cInpHist,s);
        end;
    end;
    FWnd^.drawView;
  end;
end;

procedure DoOptions;
Type ROpt=record
            x,y:string[4];
            x0,y0:string[6];
            Ig:Word;
            XSt:string[05];
            pmi,pma:string[80];
            FMode:word;
          end;

var r:TRect;
    wnd:PGraphDialog;
    Control: Word;
    Ln:PGraphInputLine;
    Vld:PMValid;
    Vld2:PMValid2;
    p:pointer;
    Opt:ROpt;
    Chk:PGraphCheckBoxes;
    i:integer;
    b,re:boolean;
    Rad:PGraphRadioButtons;

begin
  R.Assign(000,000,300,240);
  R.Move((GetMaxX-(r.b.x-r.a.x))div 2,(GetMaxY-(r.b.y-r.a.y))div 2);
  wnd:=new(PGraphDialog,init(r,Msgs^.Get(strOpt){'Options'}));
  str(config.XScale,Opt.x);
  str(config.YScale,Opt.y);
  str(config.X0,Opt.x0);
  str(config.Y0,Opt.y0);
  str(config.XStep:5:3,Opt.XSt);
  Opt.pmi:=SimpleNum(config.pmin);
  Opt.pma:=SimpleNum(config.pmax);
  Opt.FMode:=config.FncMode+1;

  If config.IsGrid then Opt.ig:=1 else Opt.ig:=0;

  with wnd^ do begin
    r.assign(070,166,133,205);
    Insert(new(PGraphBitmapButton,Init(r,'OK',cmOK,bfDefault)));
    r.assign(167,166,230,205);
    insert(New(PGraphBitmapButton,Init(R,'CANCEL',cmCancel,bfNormal)));

    R.Assign(82,008,125,028);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,4));
    Vld:=new(PMValid,init(1,9999));
    Ln^.SetValidator(Vld);
    Insert(Ln);
    R.Assign(40, 010, 79, 026);
    Insert(New(PGraphLabel, Init(R, '~X~ : ', Ln)));

    R.Assign(82,038,125,058);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,4));
    Vld:=new(PMValid,init(1,9999));
    Ln^.SetValidator(Vld);
    Insert(Ln);
    R.Assign(40, 040, 79, 056);
    Insert(New(PGraphLabel, Init(R, '~Y~ : ', Ln)));

    R.Assign(182,008,245,028);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,6));
    Vld:=new(PMValid,init(-99999,99999));
    Ln^.SetValidator(Vld);
    Insert(Ln);
    R.Assign(140, 010,179, 026);
    Insert(New(PGraphLabel, Init(R, '~X0~: ', Ln)));

    R.Assign(182,038,245,058);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,6));
    Vld:=new(PMValid,init(-99999,99999));
    Ln^.SetValidator(Vld);
    Insert(Ln);
    R.Assign(140, 040,179, 056);
    Insert(New(PGraphLabel, Init(R, '~Y0~: ', Ln)));

    R.Assign(140,068,260,088);
    Chk := New(PGraphCheckBoxes,Init(R,
      NewSItem(Msgs^.Get(strGrid){'~G~rid'},nil)));
    Insert(Chk);

    R.Assign(72,068,125,088);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,5));
    Vld2:=new(PMValid2,init(0.0009,0.10000001));
    Ln^.SetValidator(Vld2);
    Insert(Ln);
    R.Assign(020, 070,070, 086);
    Insert(New(PGraphLabel, Init(R, Msgs^.Get(strXStep){'X~S~tep:'}, Ln)));

    R.Assign(50,094,140,114);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,80));
    Insert(Ln);
    R.Assign(05, 096,46, 112);
    Insert(New(PGraphLabel, Init(R,Msgs^.Get(strPMin) {'PM~i~n='}, Ln)));

    R.Assign(200,094,280,114);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,80));
    Insert(Ln);
    R.Assign(150, 096,193, 112);
    Insert(New(PGraphLabel, Init(R,Msgs^.Get(strPMax) {'PM~a~x='}, Ln)));

    R.Assign(150,125,260,160);
    Rad:=New(PGraphRadioButtons,Init(R,
      NewSItem(Msgs^.Get(strCart){'~C~artesian'},
      NewSItem(Msgs^.Get(strPolar){'~P~olar    '},
        nil))));
    Insert(Rad);
    R.Assign(050,125,148,145);
    Insert(New(PGraphLabel, Init(R,Msgs^.Get(strCoord){'~C~oordinates'},Rad)));

    setData(opt);
  end;

 b:=FError;
 repeat
  re:=true;
  FError:=true;
  Control := DeskTop^.ExecView(Wnd);
  if control=cmOk then begin
    Wnd^.getData(Opt);
    val(opt.x,config.XScale,i);
    val(opt.y,config.YScale,i);
    val(opt.x0,config.X0,i);
    val(opt.y0,config.y0,i);
    if opt.Ig=0 then config.IsGrid:=false else config.IsGrid:=true;
    val(opt.XSt,config.XStep,i);
    Config.FncMode:=Opt.FMode-1;

        prepare(opt.pmi);
        FError:=false;
        CheckFunc(opt.pmi);
        if FError then re:=false;
        if (not FError)and(not FuncValid(CalcStr(opt.pmi,Config.EZero))) then
          config.pmin:=CalcStr(opt.pmi,config.EZero);
        prepare(opt.pma);
        FError:=false;
        CheckFunc(opt.pma);
        if FError then re:=false;
        if (not FError)and(not FuncValid(CalcStr(opt.pma,Config.EZero))) then
          config.pmax:=CalcStr(opt.pma,config.EZero);

    prepared:=false;
    SaveSettings;
  end{ else if Not b then FWnd^.draw;}
 until re;
  dispose(wnd,done);
  FError:=b;
  FWnd^.drawView;
end;

procedure Help;
begin
end;

constructor TFuncWnd.Init(var Bounds : TRect);
var
   R : TRect;
   p:pointer;
begin
  GraphWindow.Init(Bounds,Msgs^.Get(strFunc){'Functions'},wfFramed + wfTitle {+ wfClose + wfZoom + wfMove + wfGrow});
  WorkSpace^.GetExtent(R);
  p:=new(PInterior,init(r));
{  Insert(New(PGraphGrayGroup,Init(R)));}
  PInterior(p)^.GetExtent(R);
  DX:=0{5};{r.a.x;}
  dy:=0{19};{r.a.y;}
  fx:=r.b.x-r.a.x-1{-dx};
  FError:=True;
  fy:=r.b.y-r.a.y-1{-dy};
  InitGrW;
  insert(p);
{   Insert(New(PInterior, Init(R,20)));}
end;

procedure TInterior.draw;
begin
  inherited draw;
  paint(@self);
end;

procedure MValid.Error;
begin
  Sound(400);
  delay(100);
  NoSound;
end;

constructor MValid2.Init(AMin, AMax: Extended);
begin
  TFilterValidator.Init(['0'..'9','+','-','.','e','E']);
  if AMin >= 0 then ValidChars := ValidChars - ['-'];
  X_1 := AMin;
  X_2 := AMax;
end;

function MValid2.IsValid(const S: string): Boolean;
var
  Value: extended;
  Code: Integer;
begin
  IsValid := False;
  if TFilterValidator.IsValid(S) then
  begin
    Val(S, Value, Code);
    if (Code=0)and(Value>=X_1)and(Value<=X_2) then
      IsValid := True;
  end;
end;

function MValid2.Transfer(var S: String; Buffer: Pointer;
  Flag: TVTransfer): Word;
var
  Value: Single;
  Code: Integer;
begin
  if Options and voTransfer <> 0 then
  begin
    Transfer := SizeOf(Value);
    case Flag of
     vtGetData:
       begin
         Val(S, Value, Code);
         Single(Buffer^) := Value;
       end;
     vtSetData:
       Str(Single(Buffer^), S);
    end;
  end
  else
    Transfer := 0;
end;

procedure DoRegs;
Type ROpt=record
            RegArr:array[0..9] of string[40];
          end;

var r:TRect;
    wnd:PGraphDialog;
    Control: Word;
    Ln:PGraphInputLine;
    Opt:ROpt;
    i:integer;
    b,re:boolean;

begin
  R.Assign(000,000,250,315);
  R.Move((GetMaxX-(r.b.x-r.a.x))div 2,(GetMaxY-(r.b.y-r.a.y))div 2);
  wnd:=new(PGraphDialog,init(r,Msgs^.Get(strRegs){'Registers'}));
  for i:=0 to 9 do begin
    opt.RegArr[i]:=SimpleNum(config.Regs[i]);
  end;
  with wnd^ do begin
    r.assign(050,248,113,287);
    Insert(new(PGraphBitmapButton,Init(r,'OK',cmOK,bfDefault)));
    r.assign(132,248,195,287);
    insert(New(PGraphBitmapButton,Init(R,'CANCEL',cmCancel,bfNormal)));

    R.Assign(50,008,230,028);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 010,40, 026);
    Insert(New(PGraphLabel, Init(R, ' R~0~=', Ln)));

    R.Assign(50,032,230,052);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 034,40, 051);
    Insert(New(PGraphLabel, Init(R, ' R~1~=', Ln)));

    R.Assign(50,056,230,076);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(04, 058,40, 074);
    Insert(New(PGraphLabel, Init(R, ' R~2~=', Ln)));

    R.Assign(50,080,230,100);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 082,40, 099);
    Insert(New(PGraphLabel, Init(R, ' R~3~=', Ln)));

    R.Assign(50,104,230,124);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(5, 106,40, 120);
    Insert(New(PGraphLabel, Init(R, ' R~4~=', Ln)));

    R.Assign(50,128,230,148);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 130,40, 148);
    Insert(New(PGraphLabel, Init(R, ' R~5~=', Ln)));

    R.Assign(50,152,230,172);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 154,40, 170);
    Insert(New(PGraphLabel, Init(R, ' R~6~=', Ln)));

    R.Assign(50,176,230,196);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(5, 178,40, 194);
    Insert(New(PGraphLabel, Init(R, ' R~7~=', Ln)));

    R.Assign(50,200,230,220);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 202,40, 218);
    Insert(New(PGraphLabel, Init(R, ' R~8~=', Ln)));

    R.Assign(50,224,230,244);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(5, 226,40, 242);
    Insert(New(PGraphLabel, Init(R, ' R~9~=', Ln)));

    setData(opt);
  end;

  b:=FError;
  repeat
    FError:=true;
    re:=true;
    Control := DeskTop^.ExecView(Wnd);
    if control=cmOk then begin
      Wnd^.getData(Opt);
      for i:=0 to 9 do begin
        prepare(opt.RegArr[i]);
        FError:=false;
        CheckFunc(opt.RegArr[i]);
        if FError then re:=false;
        if (not FError)and(not FuncValid(CalcStr(opt.RegArr[i],Config.EZero))) then
          config.Regs[i]:=CalcStr(opt.RegArr[i],config.EZero);
      end;
      prepared:=false;
{      FWnd^.draw;}
      SaveSettings;
    end else{ if Not b then FWnd^.draw;}
  until re;
  FError:=b;
  dispose(wnd,done);
  FWnd^.drawView;
end;

{var
  qq:tMyStatImg;
  re:TRect;
    {s:TLGFImage;
    p:tpoint;
var s:string;}
begin
{  ReadSettings;}
{  RGraphMenuBar.VmtLink:=Ofs(TypeOf(MyGraphMenuBar)^);}
  RegisterType(RGraphMenuBar);
  RegisterType(RGraphStatusLine);
{  RegisterType();}
  CurStr:=FuncStr;
  if config.GraphMode<>0 then begin
    DriverType := Vesa256;
    DriverMode := config.GraphMode+Vesa256_640x400;
    VesaDriverNames[Vesa256] := drvName;
    Vesa256Modes[Vesa256_640x400] := 1;
    Vesa256Modes[Vesa256_640x480] := 2;
    Vesa256Modes[Vesa256_800x600] := 3;
    Vesa256Modes[Vesa256_1024x768] := 4;
    Vesa256Modes[Vesa256_1280x1024] := 5;
    EmulateMouseCursor := true;
  end;
  MyApp.Init;
{  MyApp.gauge^.SetUp(100);
  MyApp.gauge^.Incr(100);
  MyApp.idle;
  readkey;}
{  LoadFonts;}
{  if config.GraphMode=0 then
  @LowGraph.ConvertPixRow:=@mobj.ConvertPixRow16;}
  if Config.DInit then begin
    DoneSysError;
    DoneEvents;
    SetGraphMode(GetGraphMode);
    InitEvents;
    InitSysError;
    MyApp.Redraw;
  end else
    MenuBar^.Draw;
{  if config.GraphMode=0 then about2;}
{for i:=32*5 to 32*8 do s:=s+char(i);
  MessageBox(s,nil,$400);}
  MyApp.Run;
  MyApp.Done;
end.