program Func_gv;
{$M 32000,0,655360}
{$X+,D+}
{$Define DEBUG}
{$Define NORES}
uses LowGraph,GFonts,Graph,Objects,ExtObj,EventMan,
     Memory,GraV,Controls,GraMenu,Grapp,MsgBox,GStdDlg,Gadgets,
     GrDriver,Images,Xms,mobj;

type
       PHaltStream = ^THaltStream;
       THaltStream = object(TBufStream)
         procedure Error(Code, Info: Integer);virtual;
       end;

   GMyApp = object(GraphApplication)
      constructor Init;
   end;

const
  MaxLines          = 100;
  WinCount: Integer =   0;
  HeapSize = 250 * (1024 div 16);

var
   MyApp:GMyApp;
   Palette : word;
   ResFile : TResourceFile;
   St : PHaltStream;
   ML : PMyStatImg;
   re : TRect;
   sl : PStrListMaker;

const
   WinNum : word = 0;

const
  cmNewWin        = 255;  cmConfirm       = 254;  cmInfo          = 253;
  cmError         = 252;  cmWarning       = 251;  cmSavePic       = 250;
  cmSaveLst       = 249;  cmLoadLst       = 248;  cmPrint         = 247;
  cmInput         = 246;  cmCalc          = 245;  cmPrz           = 244;
  cmOptions       = 243;  cmSaveBmp       = 242;  cmSavePcx       = 241;
  cmSaveLgf       = 240;  cmAbout         = 239;  cmIntegr        = 238;
  cmRegs          = 237;
{  cmHelp          = 242;}


  cmNothing       = $FFFF;

  hcNewWin        = 1255;  hcConfirm       = 1254;  hcInfo          = 1253;
  hcError         = 1252;  hcWarning       = 1251;  hcSavePic       = 1250;
  hcSaveLst       = 1249;  hcLoadLst       = 1248;  hcPrint         = 1247;
  hcInput         = 1246;  hcCalc          = 1245;  hcPrz           = 1244;
  hcOptions       = 1243;  hcAbout         = 1241;  hcSaveBmp       = 1240;
  hcSavePcx       = 1239;  hcSaveLgf       = 1238;  hcIntegr        = 1237;
  hcRegs          = 1236;
{  cmHelp          = 242;}

  strAbout1 = 0;
  strAbout2 = 1;
  strAbout3 = 2;
  strAbout4 = 3;
  strAbout5 = 4;

  strCalc   = 6;
  strXStep  = 7;
  strPMin   = 8;
  strPMax   = 9;
  strCart   = 10;
  strPolar  = 11;
  strCoord  = 12;
  strGrid   = 13;

  strAbout  = 16;
  strFunc   = 17;
  strCalcul = 18;
  strIntegr = 19;
  strOpt    = 20;
  strRegs   = 21;

  strSBMP   = 32;
  strSLGF   = 33;
  strSPCX   = 34;
  strSFL    = 35;
  strLFL    = 36;
  strInpF   = 37;
  strBadI   = 38;
  strE_DF   = 39;
  strError  = 40;
  strE_LD   = 41;
  strE_CCD  = 42;
  strTDIs   = 43;
  strUseF   = 44;

  strEUF    = 46;
  strEEBE   = 47;
  strEEE    = 48;
  strESE    = 49;
  strECE    = 50;
  strEBBE   = 51;

var
  R,R1 : TRect;
  MaxX, MaxY  : word;     { The maximum resolution of the screen }
  ErrorCode   : integer;  { Reports any graphics errors }
  MaxColor    : word;     { The maximum color value available }
  OldExitProc : Pointer;  { Saves exit procedure address }
  PathToDriver : string;
  Ch : Char;
  i : integer;

constructor GMyApp.Init;
begin
  Inherited init;
end;

procedure THaltStream.Error(Code, Info: Integer);
     begin
       Writeln('Stream error: ', Code, ' (', Info, ')');
       Halt(1);
end;

procedure InitMenuBar;
var R: TRect;
    MenuBar: PGraphMenuBar;
begin
{  GetExtent(R);
  R.B.Y := R.A.Y + MenuItemHeight;}
  r.assign(0,0,0,0);
  MenuBar := New(PGraphMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ile', hcNoContext, NewMenu(
{      NewItem('~S~ave as a picture', 'Alt-G', kbAltG, cmSavePic, hcSavePic,}
      NewSubMenu('~S~ave as a picture...', hcSavePic, NewMenu(
        NewItem('Save as .~B~MP','Ctrl-B',{kbCtrlB}$3002,cmSaveBmp,hcSaveBmp,
        NewItem('Save as .~P~CX','Ctrl-P',{kbCtrlP}$1910,cmSavePcx,hcSavePcx,
        NewItem('Save as .~L~GF','Ctrl-L',{kbCtrlL}$260C,cmSaveLgf,hcSaveLgf,
        nil)))),
      NewItem('S~a~ve list', 'F2', kbF2, cmSaveLst, hcSaveLst,
      NewItem('~L~oad list', 'F3', kbF3, cmLoadLst, hcLoadLst,
      NewItem('~P~rint', 'Alt-P', kbAltP, cmPrint, hcPrint,
      NewLine(
      NewItem('~D~os shell', 'Alt-D', kbAltD{NoKey}, cmDosShell, hcDosShell,
      NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit, hcExit,
      nil)))))))),
    NewSubMenu('F~u~nctions', hcNoContext, NewMenu(
      NewItem('~I~nput', 'Alt-I', kbAltI, cmInput, hcInput,
      NewItem('~D~erivative', 'Alt-T', kbAltT, cmPrz, hcPrz,
      NewItem('~C~alculation', 'Alt-C', kbAltC, cmCalc, hcCalc,
      NewItem('I~n~tegral', 'Alt-N', kbAltN, cmIntegr, hcIntegr,
      NewLine(
      NewItem('~O~ptions', 'Alt-M', kbAltM, cmOptions, hcOptions,
      NewItem('~R~egisters', 'Alt-R', kbAltR, cmRegs, hcRegs,
      nil)))))))),
    NewSubMenu('?',hcNoContext,NewMenu(
      NewItem('~H~elp','F1',kbF1,cmHelp,hcInfo,
      NewItem('~A~bout','',kbNoKey,cmAbout,hcAbout,
      nil))),
    nil))
  ))));
  ResFile.put(MenuBar,'MenuBarEng');
  Dispose(menuBar,done);
  MenuBar := New(PGraphMenuBar, Init(R, NewMenu(
    NewSubMenu('~~', hcNoContext, NewMenu(
{      NewItem('~~࠭ ⨭', 'Alt-G', kbAltG, cmSavePic, hcSavePic,}
      NewSubMenu('~~࠭ ⨭ ...', hcSavePic, NewMenu(
        NewItem('࠭  .~B~MP','Ctrl-B',{kbCtrlB}$3002,cmSaveBmp,hcSaveBmp,
        NewItem('࠭  .~P~CX','Ctrl-P',{kbCtrlP}$1910,cmSavePcx,hcSavePcx,
        NewItem('࠭  .~L~GF','Ctrl-L',{kbCtrlL}$260C,cmSaveLgf,hcSaveLgf,
        nil)))),
      NewItem('~~࠭ ᯨ᮪', 'F2', kbF2, cmSaveLst, hcSaveLst,
      NewItem('~~㧨 ᯨ᮪', 'F3', kbF3, cmLoadLst, hcLoadLst,
      NewItem('~~', 'Alt-P', kbAltP, cmPrint, hcPrint,
      NewLine(
      NewItem('~~६ 室', 'Alt-D', kbAltD{NoKey}, cmDosShell, hcDosShell,
      NewItem('~~ ࠡ', 'Alt-X', kbAltX, cmQuit, hcExit,
      nil)))))))),
    NewSubMenu('~~樨', hcNoContext, NewMenu(
      NewItem('~~', 'Alt-I', kbAltI, cmInput, hcInput,
      NewItem('~~ந', 'Alt-T', kbAltT, cmPrz, hcPrz,
      NewItem('~~᫨', 'Alt-C', kbAltC, cmCalc, hcCalc,
      NewItem('~~⥣ࠫ', 'Alt-N', kbAltN, cmIntegr, hcIntegr,
      NewLine(
      NewItem('~~ன','Alt-M', kbAltM, cmOptions, hcOptions,
      NewItem('~~','Alt-R', kbAltR, cmRegs, hcRegs,
      nil)))))))),
    NewSubMenu('?',hcNoContext,NewMenu(
      NewItem('~~','F1',kbF1,cmHelp,hcInfo,
      NewItem('~~ ᥡ','',kbNoKey,cmAbout,hcAbout,
      nil))),
    nil))
  ))));
  ResFile.put(MenuBar,'MenuBarRus');
  Dispose(menuBar,done);
{  MenuBar}
end;

procedure InitStatusLine;
var
  R: TRect;
  StatusLine:PGraphStatusLine;
begin
{  GetExtent(R);
  R.A.Y := R.B.Y - StatusItemHeight;}
  r.assign(0,0,0,0);
  StatusLine:=New(PGraphStatusLine, Init(R,
    NewStatusDef(0,0,{ $FFFF,}
{      NewStatusKey('~Alt-G~ SavePic', kbAltG, cmSavePic,}
      NewStatusKey('~Alt-I~ Input', kbAltI, cmInput,
      NewStatusKey('~Alt-M~ Options', kbAltM, cmOptions,
      NewStatusKey('~Alt-D~ Dos Shell', kbAltD, cmDosShell,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('', kbCtrlF5, cmResize,
      nil)))))),
    NewStatusDef(hcSavePic,hcSavePic,
      NewStatusKey('Save the graph as a picture', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcSaveBmp,hcSaveBmp,
      NewStatusKey('Save the graph as a windows bitmap', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcSavePcx,hcSavePcx,
      NewStatusKey('Save the graph as ZSoft''s .PCX', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcSaveLgf,hcSaveLgf,
      NewStatusKey('Save the graph as a linear graph format picture', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcSaveLst,hcSaveLst,
      NewStatusKey('Save functions list', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcLoadLst,hcLoadLst,
      NewStatusKey('Load functions list', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcPrint,hcPrint,
      NewStatusKey('Print the graph', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcDosShell,hcDosShell,
      NewStatusKey('Temporary exit to DOS', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcExit,hcExit,
      NewStatusKey('Exit to DOS', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcInput,hcInput,
      NewStatusKey('Input new function', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcPrz,hcPrz,
      NewStatusKey('Calculate derivative', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcOptions,hcOptions,
      NewStatusKey('Options...', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcInfo,hcInfo,
      NewStatusKey('Help me!', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcAbout,hcAbout,
      NewStatusKey('About me', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcCalc,hcCalc,
      NewStatusKey('Calculate value of function in point',kbNoKey,cmNothing,
      nil),
    NewStatusDef(hcIntegr,hcIntegr,
      NewStatusKey('Calculate the integral',kbNoKey,cmNothing,
      nil),
    NewStatusDef(hcRegs,hcRegs,
      NewStatusKey('Setup values of registers',kbNoKey,cmNothing,
      nil),
    nil))))))))))))))))))));
  ResFile.put(StatusLine,'StatusLineEng');
  Dispose(StatusLine,done);
  r.assign(0,0,0,0);
  StatusLine:=New(PGraphStatusLine, Init(R,
    NewStatusDef(0,0,{ $FFFF,}
{      NewStatusKey('~Alt-G~ ⨭', kbAltG, cmSavePic,}
      NewStatusKey('~Alt-I~ ', kbAltI, cmInput,
      NewStatusKey('~Alt-M~ ன', kbAltM, cmOptions,
      NewStatusKey('~Alt-D~  Dos', kbAltD, cmDosShell,
      NewStatusKey('~F10~ ', kbF10, cmMenu,
      NewStatusKey('~Alt-X~ 室', kbAltX, cmQuit,
      NewStatusKey('', kbCtrlF5, cmResize,
      nil)))))),
    NewStatusDef(hcSavePic,hcSavePic,
      NewStatusKey('࠭ 䨪 ⨭', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcSaveBmp,hcSaveBmp,
      NewStatusKey('࠭ 䨪  BMP''', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcSavePcx,hcSavePcx,
      NewStatusKey('࠭ 䨪  PCX', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcSaveLgf,hcSaveLgf,
      NewStatusKey('࠭ 䨪  LGF', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcSaveLst,hcSaveLst,
      NewStatusKey('࠭ ᯨ᮪ 㭪権', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcLoadLst,hcLoadLst,
      NewStatusKey('㧨 ᯨ᮪ 㭪権', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcPrint,hcPrint,
      NewStatusKey(' 䨪', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcDosShell,hcDosShell,
      NewStatusKey('६ 室  DOS', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcExit,hcExit,
      NewStatusKey(' ࠡ,   OS', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcInput,hcInput,
      NewStatusKey('  㭪樨', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcPrz,hcPrz,
      NewStatusKey('᫥ ந', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcOptions,hcOptions,
      NewStatusKey('ன ⮡ࠦ 䨪...', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcInfo,hcInfo,
      NewStatusKey('!', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcAbout,hcAbout,
      NewStatusKey(' ᥡ, ', kbNoKey, cmNothing,
      nil),
    NewStatusDef(hcCalc,hcCalc,
      NewStatusKey('᫨ 祭 㭪樨  窥',kbNoKey,cmNothing,
      nil),
    NewStatusDef(hcIntegr,hcIntegr,
      NewStatusKey('᫨ । ⥣ࠫ',kbNoKey,cmNothing,
      nil),
    NewStatusDef(hcRegs,hcRegs,
      NewStatusKey(' 祭 ॣ஢',kbNoKey,cmNothing,
      nil),
    nil))))))))))))))))))));
  ResFile.put(StatusLine,'StatusLineRus');
  Dispose(StatusLine,done);
end;

procedure SaveFonts;
begin
  ResFile.put(fonts^.items^[1],'Font8x8');
  ResFile.put(fonts^.items^[2],'Font8x14');
  ResFile.put(fonts^.items^[3],'Font8x16');
end;

procedure SaveMsgs;
begin
  new(sl,init(16384,64));
  sl^.put(strAbout1,'Written by Fomin Pavel.1999.Ivanovo,Russia.');
  sl^.put(strAbout2,'Fomin Pavel AKA Pasha 1st AKA 2:5026/45.13');
  sl^.put(strAbout3,'All rights reserved.');
  sl^.put(strAbout4,'Phone: no, no, you can''t find me :].');
  sl^.put(strAbout5,'Used: Graphic Vision, Borland Pascal v7.0.');

  sl^.put(strCalc,'~C~alculate');
  sl^.put(strXStep,'X~S~tep:');
  sl^.put(strPMin,'m~i~n=');
  sl^.put(strPMax,'m~a~x=');
  sl^.put(strCart,'C~artesian');
  sl^.put(strPolar,'~P~olar');
  sl^.put(strCoord,'~C~oordinates');
  sl^.put(strGrid,'~G~rid');

  sl^.put(strAbout,'About');
  sl^.put(strFunc,'Functions');
  sl^.put(strCalcul,'Calculation');
  sl^.put(strIntegr,'Integrals');
  sl^.put(strOpt,'Options');
  sl^.put(strRegs,'Registers');

  sl^.put(strSBMP,'Save as a bitmap file');
  sl^.put(strSLGF,'Save as a .lgf file');
  sl^.put(strSPCX,'Save as a .pcx file');
  sl^.put(strSFL,'Save functions list');
  sl^.put(strLFL,'Add functions from file to list');
  sl^.put(strInpF,'Input function');
  sl^.put(strBadI,'Bad input value');
  sl^.put(strE_DF,'X isn''t in D(F)');
  sl^.put(strError,'Error!');
  sl^.put(strE_LD,'Error! Derivative is too long!');
  sl^.put(strE_CCD,'Cannot calculate the derivative!');
  sl^.put(strTDIs,'The derivative is');
  sl^.put(strUseF,'Use as a function?');

  sl^.put(strEUF,'Unknown function');
  sl^.put(strEEBE,') expected');
  sl^.put(strEEE,'Expression expected');
  sl^.put(strESE,'Syntax error');
  sl^.put(strECE,', expected');
  sl^.put(strEBBE,'( expected');

  ResFile.Put(sl,'MsgsEng');
  dispose(sl,done);

  new(sl,init(16384,64));
  sl^.put(strAbout1,':  , 1999. , .');
  sl^.put(strAbout2,'Fomin Pavel AKA Pasha 1st AKA 2:5026/45.13');
  sl^.put(strAbout3,' ࠢ 饭.');
  sl^.put(strAbout4,'ᯮ짮: Graphic Vision,');
  sl^.put(strAbout5,'Borland Pascal v7.0.');

  sl^.put(strCalc,'~~᫨');
  sl^.put(strXStep,'X ~~:');
  sl^.put(strPMin,'m~i~n=');
  sl^.put(strPMax,'m~a~x=');
  sl^.put(strCart,'~~⮢');
  sl^.put(strPolar,'~~ୠ');
  sl^.put(strCoord,'~~न');
  sl^.put(strGrid,'~~⪠');

  sl^.put(strAbout,' ᥡ');
  sl^.put(strFunc,'㭪樨');
  sl^.put(strCalcul,'᫥');
  sl^.put(strIntegr,'⥣ࠫ');
  sl^.put(strOpt,'ன');
  sl^.put(strRegs,'');

  sl^.put(strSBMP,'࠭  .BMP');
  sl^.put(strSLGF,'࠭  .LGF');
  sl^.put(strSPCX,'࠭  .PCX');
  sl^.put(strSFL,'࠭ ᯨ᮪ 㭪権');
  sl^.put(strLFL,' ᯨ᮪ 㭪権  䠩');
  sl^.put(strInpF,' 㭪樨');
  sl^.put(strBadI,'४   訡 ᫥');
  sl^.put(strE_DF,'X   ');
  sl^.put(strError,'訡!');
  sl^.put(strE_LD,'訡! ९ ப!');
  sl^.put(strE_CCD,'  ᫨ ந!');
  sl^.put(strTDIs,'ந:');
  sl^.put(strUseF,'⠢  㭪?');

  sl^.put(strEUF,'⭠ 㭪');
  sl^.put(strEEBE,') ');
  sl^.put(strEEE,'ய饭 ࠦ');
  sl^.put(strESE,'⠪᪠ 訡');
  sl^.put(strECE,', ');
  sl^.put(strEBBE,'( ');

  ResFile.Put(sl,'MsgsRus');
  dispose(sl,done);
end;

begin
  DriverType := Vesa256;
  DriverMode := Vesa256_800x600;
  VesaDriverNames[Vesa256] := 'videodr';
  Vesa256Modes[Vesa256_640x400] := 1;
  Vesa256Modes[Vesa256_640x480] := 2;
  Vesa256Modes[Vesa256_800x600] := 3;
  Vesa256Modes[Vesa256_1024x768] := 4;
  Vesa256Modes[Vesa256_1280x1024] := 5;
  EmulateMouseCursor := true;
  MyApp.Init;
  RegisterType(RGraphMenuBar);
  RegisterType(RGraphStatusLine);
  RegisterType(RStrListMaker);
  st:=New(PHaltStream,init('Objects.res',stCreate,1046));
  ResFile.Init(st);
  new(ML,loadBMP(re,'e.bmp',256));
  ResFile.put(ml,'ML8');
  dispose(ml,done);
  new(ML,loadBMP(re,'e.bmp',16));
  ResFile.put(ml,'ML4');
  dispose(ml,done);
  InitMenuBar;
  InitStatusLine;
  SaveFonts;
  SaveMsgs;
  ResFile.done;
  MyApp.Done;
end.